(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var SandstormPowerbox;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-ui-powerbox":{"powerbox-server.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-ui-powerbox/powerbox-server.js                                                                  //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});
// Sandstorm - Personal Cloud Sandbox                                                                                 //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                              //
// All rights reserved.                                                                                               //
//                                                                                                                    //
// Licensed under the Apache License, Version 2.0 (the "License");                                                    //
// you may not use this file except in compliance with the License.                                                   //
// You may obtain a copy of the License at                                                                            //
//                                                                                                                    //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       //
//                                                                                                                    //
// Unless required by applicable law or agreed to in writing, software                                                //
// distributed under the License is distributed on an "AS IS" BASIS,                                                  //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           //
// See the License for the specific language governing permissions and                                                //
// limitations under the License.                                                                                     //
                                                                                                                      //
var Crypto = Npm.require("crypto");                                                                                   // 17
var Capnp = Npm.require("capnp");                                                                                     // 18
var Powerbox = Capnp.importSystem("sandstorm/powerbox.capnp");                                                        // 19
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                              // 20
                                                                                                                      //
// TODO(cleanup): lift this out of a package so it can share with async-helpers.js                                    //
var Future = Npm.require("fibers/future");                                                                            // 23
var promiseToFuture = function promiseToFuture(promise) {                                                             // 24
  var result = new Future();                                                                                          // 25
  promise.then(result["return"].bind(result), result["throw"].bind(result));                                          // 26
  return result;                                                                                                      // 27
};                                                                                                                    // 28
                                                                                                                      //
var waitPromise = function waitPromise(promise) {                                                                     // 30
  return promiseToFuture(promise).wait();                                                                             // 31
};                                                                                                                    // 32
                                                                                                                      //
function encodePowerboxDescriptor(desc) {                                                                             // 34
  return Capnp.serializePacked(Powerbox.PowerboxDescriptor, desc).toString("base64").replace(/\+/g, "-").replace(/\//g, "_");
}                                                                                                                     // 39
                                                                                                                      //
Meteor.methods({                                                                                                      // 41
  newFrontendRef: function newFrontendRef(sessionId, frontendRef) {                                                   // 42
    // Completes a powerbox request for a frontendRef capability.                                                     //
    check(sessionId, String);                                                                                         // 44
    // frontendRef is type-checked by frontendRefRegistry.validate(), below.                                          //
                                                                                                                      //
    var db = this.connection.sandstormDb;                                                                             // 47
    var frontendRefRegistry = this.connection.frontendRefRegistry;                                                    // 48
                                                                                                                      //
    var session = db.collections.sessions.findOne({ _id: sessionId, userId: this.userId || { $exists: false } });     // 50
    if (!session) {                                                                                                   // 52
      throw new Meteor.Error(403, "Invalid session ID");                                                              // 53
    }                                                                                                                 // 54
                                                                                                                      //
    var _frontendRefRegistry$ = frontendRefRegistry.validate(db, session, frontendRef);                               // 42
                                                                                                                      //
    var descriptor = _frontendRefRegistry$.descriptor;                                                                // 42
    var requirements = _frontendRefRegistry$.requirements;                                                            // 42
                                                                                                                      //
    descriptor = encodePowerboxDescriptor(descriptor);                                                                // 57
                                                                                                                      //
    var grainId = session.grainId;                                                                                    // 59
    var apiTokenOwner = {                                                                                             // 60
      clientPowerboxRequest: {                                                                                        // 61
        grainId: grainId,                                                                                             // 62
        introducerIdentity: session.identityId,                                                                       // 63
        sessionId: session._id                                                                                        // 64
      }                                                                                                               // 61
    };                                                                                                                // 60
                                                                                                                      //
    var cap = frontendRefRegistry.create(db, frontendRef, requirements);                                              // 68
    var sturdyRef = waitPromise(cap.save(apiTokenOwner)).sturdyRef.toString();                                        // 69
    cap.close();                                                                                                      // 70
    return { sturdyRef: sturdyRef, descriptor: descriptor };                                                          // 71
  },                                                                                                                  // 72
  fulfillUiViewRequest: function fulfillUiViewRequest(sessionId, identityId, grainId, petname, roleAssignment, ownerGrainId) {
    var db = this.connection.sandstormDb;                                                                             // 75
    check(sessionId, String);                                                                                         // 76
    check(identityId, String);                                                                                        // 77
    check(grainId, String);                                                                                           // 78
    check(roleAssignment, db.roleAssignmentPattern);                                                                  // 79
    check(petname, String);                                                                                           // 80
    check(ownerGrainId, String);                                                                                      // 81
                                                                                                                      //
    if (!this.userId || !db.userHasIdentity(this.userId, identityId)) {                                               // 83
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                              // 84
    }                                                                                                                 // 85
                                                                                                                      //
    var provider = {                                                                                                  // 87
      identityId: identityId,                                                                                         // 88
      accountId: this.userId                                                                                          // 89
    };                                                                                                                // 87
                                                                                                                      //
    var title = db.userGrainTitle(grainId, this.userId, identityId);                                                  // 92
                                                                                                                      //
    var descriptor = encodePowerboxDescriptor({                                                                       // 94
      tags: [{ id: Grain.UiView.typeId,                                                                               // 95
        value: Capnp.serialize(Grain.UiView.PowerboxTag, { title: title })                                            // 97
      }]                                                                                                              // 96
    });                                                                                                               // 94
                                                                                                                      //
    var owner = {                                                                                                     // 102
      clientPowerboxRequest: {                                                                                        // 103
        grainId: ownerGrainId,                                                                                        // 104
        introducerIdentity: identityId,                                                                               // 105
        sessionId: sessionId                                                                                          // 106
      }                                                                                                               // 103
    };                                                                                                                // 102
                                                                                                                      //
    var result = SandstormPermissions.createNewApiToken(db, provider, grainId, petname, roleAssignment, owner);       // 110
                                                                                                                      //
    return {                                                                                                          // 113
      sturdyRef: result.token,                                                                                        // 114
      descriptor: descriptor                                                                                          // 115
    };                                                                                                                // 113
  }                                                                                                                   // 117
});                                                                                                                   // 41
                                                                                                                      //
var PowerboxOption = function () {                                                                                    //
  function PowerboxOption(fields) {                                                                                   // 121
    _classCallCheck(this, PowerboxOption);                                                                            // 121
                                                                                                                      //
    _.extend(this, fields);                                                                                           // 122
  }                                                                                                                   // 123
                                                                                                                      //
  PowerboxOption.prototype.intersect = function intersect(other) {                                                    //
    // Intersect two options with the same ID. Used when combining matches from multiple tags                         //
    // in the same descriptor. The tags are a conjunction.                                                            //
    //                                                                                                                //
    // Returns true if there was any overlap, or false if there was no overlap and therefore the                      //
    // option should be dropped.                                                                                      //
    //                                                                                                                //
    // TODO(cleanup): How do we factor out the type-specific logic through FrontendRefRegistry?                       //
                                                                                                                      //
    if (other._id != this._id) {                                                                                      // 134
      throw new Error("can only merge options with the same ID");                                                     // 135
    }                                                                                                                 // 136
                                                                                                                      //
    if (other.grainId) {                                                                                              // 138
      if (this.uiView && !other.uiView) delete this.uiView;                                                           // 139
      if (this.hostedObject && !other.hostedObject) delete this.hostedObject;                                         // 140
      return !!(this.uiView || this.hostedObject);                                                                    // 141
    } else if ((this.frontendRef || {}).verifiedEmail) {                                                              // 142
      // Try to hint which verifierId matched.                                                                        //
      if (this.frontendRef.verifiedEmail.verifierId) {                                                                // 144
        if (other.frontendRef.verifiedEmail.verifierId) {                                                             // 145
          // Can't match multiple verifiers at once.                                                                  //
          return false;                                                                                               // 147
        }                                                                                                             // 148
      } else if (other.frontendRef.verifiedEmail.verifierId) {                                                        // 149
        // One request did not specify any verifierId, the other did, and both matched, so use                        //
        // the verifierId.                                                                                            //
        this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                       // 152
      }                                                                                                               // 153
                                                                                                                      //
      return true;                                                                                                    // 155
    } else {                                                                                                          // 156
      // No intersection logic needed for other types.                                                                //
      return true;                                                                                                    // 158
    }                                                                                                                 // 159
  };                                                                                                                  // 160
                                                                                                                      //
  PowerboxOption.prototype.union = function union(other) {                                                            //
    // Union two options with the same ID. Used when combining matches from multiple descriptors.                     //
    // The descriptors are a disjunction.                                                                             //
    //                                                                                                                //
    // TODO(cleanup): How do we factor out the type-specific logic through FrontendRefRegistry?                       //
                                                                                                                      //
    if (other._id != this._id) {                                                                                      // 168
      throw new Error("can only merge options with the same ID");                                                     // 169
    }                                                                                                                 // 170
                                                                                                                      //
    if (other.grainId) {                                                                                              // 172
      if (!this.uiView && other.uiView) this.uiView = other.uiView;                                                   // 173
      if (!this.hostedObject && other.hostedObject) this.hostedObject = other.hostedObject;                           // 174
    } else if ((this.frontendRef || {}).verifiedEmail) {                                                              // 175
      // If this doesn't have a verifierId but other does, copy it over.                                              //
      if (!this.frontendRef.verifiedEmail.verifierId && other.frontendRef.verifiedEmail.verifierId) {                 // 177
        this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                       // 179
      }                                                                                                               // 180
    }                                                                                                                 // 181
  };                                                                                                                  // 182
                                                                                                                      //
  PowerboxOption.prototype.subtract = function subtract(other) {                                                      //
    // Remove `other` from this. Used when `other` is a match deemed unacceptable. Returns true                       //
    // if there's anything left, false otherwise.                                                                     //
                                                                                                                      //
    if (other._id != this._id) {                                                                                      // 188
      throw new Error("can only merge options with the same ID");                                                     // 189
    }                                                                                                                 // 190
                                                                                                                      //
    if (other.grainId) {                                                                                              // 192
      if (this.uiView && other.uiView) delete this.uiView;                                                            // 193
      if (this.hostedObject && other.hostedObject) delete this.hostedObject;                                          // 194
      return !!(this.uiView || this.hostedObject);                                                                    // 195
    } else {                                                                                                          // 196
      return false;                                                                                                   // 197
    }                                                                                                                 // 198
  };                                                                                                                  // 199
                                                                                                                      //
  return PowerboxOption;                                                                                              //
}();                                                                                                                  //
                                                                                                                      //
function registerUiViewQueryHandler(frontendRefRegistry) {                                                            // 202
  // TODO(cleanup): Maybe this belongs in a different file? But where?                                                //
                                                                                                                      //
  frontendRefRegistry.register({                                                                                      // 205
    typeId: Grain.UiView.typeId,                                                                                      // 206
                                                                                                                      //
    query: function query(db, userId, value) {                                                                        // 208
      if (!userId) return [];                                                                                         // 209
                                                                                                                      //
      // TODO(someday): Allow `value` to specify app IDs to filter for.                                               //
                                                                                                                      //
      var sharedGrainIds = db.userApiTokens(userId).map(function (token) {                                            // 213
        return token.grainId;                                                                                         // 213
      });                                                                                                             // 213
      var ownedGrainIds = db.userGrains(userId).map(function (grain) {                                                // 214
        return grain._id;                                                                                             // 214
      });                                                                                                             // 214
                                                                                                                      //
      return _.uniq(sharedGrainIds.concat(ownedGrainIds)).map(function (grainId) {                                    // 216
        return new PowerboxOption({                                                                                   // 217
          _id: "grain-" + grainId,                                                                                    // 218
          grainId: grainId,                                                                                           // 219
          uiView: {},                                                                                                 // 220
          cardTemplate: "grainPowerboxCard",                                                                          // 221
          configureTemplate: "uiViewPowerboxConfiguration"                                                            // 222
        });                                                                                                           // 217
      });                                                                                                             // 224
    }                                                                                                                 // 225
  });                                                                                                                 // 205
}                                                                                                                     // 227
                                                                                                                      //
Meteor.publish("powerboxOptions", function (requestId, descriptorList) {                                              // 229
  var _this = this;                                                                                                   // 229
                                                                                                                      //
  // Performs a powerbox query, returning options to present to the user in the powerbox.                             //
  // `descriptorList` is an array of `PowerboxDescriptor`s, each individually serialized in                           //
  // packed format and base64-encoded. The publish populates a pseudo-collection called                               //
  // `powerboxOptions`. Each item has the following fields:                                                           //
  //                                                                                                                  //
  //   _id: Unique identifier string.                                                                                 //
  //      TODO(soon): This ID string is often a human-readable name like "frontendref-ipinterface"                    //
  //        and is only guaranteed to be unique because we currently don't allow a client to have                     //
  //        multiple powerbox requests active at the same time. We should strengthen this uniqueness                  //
  //        guarentee, possibly by incorporating `requestId`. Note, however, that Meteor requires `_id`               //
  //        to be either a string or an `ObjectID`.                                                                   //
  //   requestId: The value of `requestId` that was passed in when subscribing.                                       //
  //   matchQuality: "preferred" or "acceptable" ("unacceptable" options aren't returned).                            //
  //   frontendRef: If present, selecting this option means creating a simple frontendRef. The                        //
  //       field value should be passed back to the method `newFrontendRef` verbatim. The format                      //
  //       of the field is the same as ApiTokens.frontendRef.                                                         //
  //   grainId: If present, this option selects a grain to satisfy the request. One or both of                        //
  //       `uiView` and `hostedObject` will be present. Mutually exclusive with `frontendRef`.                        //
  //   uiView: If present, this option creates a UiView for a grain. The UI should allow the user                     //
  //       to choose a role to grant. Only present when `grainId` is also present. `uiView` is an                     //
  //       object with the fields:                                                                                    //
  //     TODO(someday): Some sort of indication of what options the powerbox should give the user                     //
  //         as far as which permissions to grant? Unclear if any app would ever want to specify                      //
  //         permissions when requesting a plain UiView.                                                              //
  //   hostedObject: If present, this grain advertises that it publishes capabilities that might                      //
  //       match the query. If selected, a request session to the grain embedded should be shown                      //
  //       embedded in the powerbox and the same request should be passed to it. Only present when                    //
  //       `grainId` is also present. `hostedObject`, when present, is (for now) an empty object.                     //
  //   cardTemplate: Names the client-side template to use to display this powerbox option. The                       //
  //       template's data context will be a "card" object as returned by                                             //
  //       SandstormPowerboxRequest.filteredCardData(). Also, the template definition (in client                      //
  //       code) may have a static method `powerboxIconSrc` which takes the card as a parameter                       //
  //       and returns the URL of the icon to display next to the option.                                             //
  //   configureTemplate: If selecting this option should then show a further dialog, names the                       //
  //       client-side template for that dialog.                                                                      //
  //   ...: Other fields may be added for consumption by the client-side template.                                    //
                                                                                                                      //
  var results = {};                                                                                                   // 267
  var db = this.connection.sandstormDb;                                                                               // 268
  var frontendRefRegistry = this.connection.frontendRefRegistry;                                                      // 269
                                                                                                                      //
  if (descriptorList.length > 0) {                                                                                    // 271
    var descriptorMatches = descriptorList.map(function (packedDescriptor) {                                          // 272
      // Decode the descriptor.                                                                                       //
      // TODO(now): Also single-segment? Canonical?                                                                   //
                                                                                                                      //
      // Note: Node's base64 decoder also accepts URL-safe base64, so no need to translate.                           //
      var descriptor = Capnp.parse(Powerbox.PowerboxDescriptor, new Buffer(packedDescriptor, "base64"), { packed: true });
                                                                                                                      //
      if (!descriptor.tags || descriptor.tags.length === 0) return {};                                                // 282
                                                                                                                      //
      // Expand each tag into a match map.                                                                            //
      var tagMatches = descriptor.tags.map(function (tag) {                                                           // 285
        var result = {};                                                                                              // 286
                                                                                                                      //
        frontendRefRegistry.query(db, _this.userId, tag).forEach(function (option) {                                  // 288
          result[option._id] = new PowerboxOption(option);                                                            // 289
        });                                                                                                           // 290
                                                                                                                      //
        return result;                                                                                                // 292
      });                                                                                                             // 293
                                                                                                                      //
      // Intersect two tags' matches.                                                                                 //
      var matches = tagMatches.reduce(function (a, b) {                                                               // 296
        for (var id in a) {                                                                                           // 297
          if (id in b) {                                                                                              // 298
            if (!a[id].intersect(b[id])) {                                                                            // 299
              // Empty intersection.                                                                                  //
              delete a[id];                                                                                           // 301
            }                                                                                                         // 302
          } else {                                                                                                    // 303
            // This match only exists in a, not b, so delete it.                                                      //
            delete a[id];                                                                                             // 305
          }                                                                                                           // 306
        }                                                                                                             // 307
                                                                                                                      //
        return a;                                                                                                     // 309
      });                                                                                                             // 310
                                                                                                                      //
      return { descriptor: descriptor, matches: matches };                                                            // 312
    });                                                                                                               // 313
                                                                                                                      //
    // TODO(someday): The implementation of matchQuality here is not quite right. In theory, we're                    //
    //   supposed to compare descriptors to determine which ones are more specific than which                         //
    //   others, and prefer the most-specific match. For now, though, I've implemented a heuristic:                   //
    //   consider each descriptor in order. If it is "unacceptable", have it cancel out any                           //
    //   matches seen previously. Otherwise, take the maximum match quality. This will usually                        //
    //   produce the same results as long as "unacceptable" descriptors are placed last in the                        //
    //   list.                                                                                                        //
                                                                                                                      //
    var matches = descriptorMatches.reduce(function (finalMatches, clause) {                                          // 323
      if (clause.matchQuality === "unacceptable") {                                                                   // 324
        // Remove b's matches from a.                                                                                 //
        for (var id in clause.matches) {                                                                              // 326
          if (id in finalMatches) {                                                                                   // 327
            if (!finalMatches[id].subtract(clause.matches[id])) {                                                     // 328
              delete finalMatches[id];                                                                                // 329
            }                                                                                                         // 330
          }                                                                                                           // 331
        }                                                                                                             // 332
                                                                                                                      //
        return finalMatches;                                                                                          // 334
      } else {                                                                                                        // 335
        for (var _id in clause.matches) {                                                                             // 336
          if (_id in finalMatches) {                                                                                  // 337
            finalMatches[_id].union(clause.matches[_id]);                                                             // 338
          } else {                                                                                                    // 339
            finalMatches[_id] = clause.matches[_id];                                                                  // 340
          }                                                                                                           // 341
                                                                                                                      //
          if (clause.matchQuality === "preferred") {                                                                  // 343
            finalMatches[_id].matchQuality = "preferred";                                                             // 344
          }                                                                                                           // 345
        }                                                                                                             // 346
                                                                                                                      //
        return finalMatches;                                                                                          // 348
      }                                                                                                               // 349
    }, {});                                                                                                           // 350
                                                                                                                      //
    for (var id in matches) {                                                                                         // 352
      if (!matches[id].matchQuality) {                                                                                // 353
        matches[id].matchQuality = "acceptable";                                                                      // 354
      }                                                                                                               // 355
                                                                                                                      //
      matches[id].requestId = requestId;                                                                              // 357
      this.added("powerboxOptions", id, matches[id]);                                                                 // 358
    }                                                                                                                 // 359
  }                                                                                                                   // 360
                                                                                                                      //
  // TODO(someday): Make reactive? Seems annoying.                                                                    //
                                                                                                                      //
  this.ready();                                                                                                       // 364
});                                                                                                                   // 365
                                                                                                                      //
SandstormPowerbox = { registerUiViewQueryHandler: registerUiViewQueryHandler };                                       // 367
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-ui-powerbox/powerbox-server.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-ui-powerbox'] = {}, {
  SandstormPowerbox: SandstormPowerbox
});

})();

//# sourceMappingURL=sandstorm-ui-powerbox.js.map
