(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Identicon = Package['sandstorm-identicons'].Identicon;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, ApiTokens, ApiHosts, Notifications, ActivitySubscriptions, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, allowDevAccounts, sendReferralProgramNotification, roleAssignmentPattern, SandstormDb, appName, addStaticAsset;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/db.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file defines the database schema.                                                                              //
                                                                                                                       //
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                         //
// query it makes, so you can see if it's doing queries too often, etc.                                                //
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                                // 21
  (function () {                                                                                                       // 21
    var oldFind = Mongo.Collection.prototype.find;                                                                     // 22
    Mongo.Collection.prototype.find = function () {                                                                    // 23
      console.log(this._prefix, arguments);                                                                            // 24
      return oldFind.apply(this, arguments);                                                                           // 25
    };                                                                                                                 // 26
  })();                                                                                                                // 21
}                                                                                                                      // 27
                                                                                                                       //
// Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                      //
if (Meteor.isServer) {                                                                                                 // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                            // 31
} else {                                                                                                               // 32
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                     // 33
}                                                                                                                      // 34
                                                                                                                       //
// TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                            //
                                                                                                                       //
// Users = new Mongo.Collection("users");                                                                              //
// The users collection is special and can be accessed through `Meteor.users`.                                         //
// See https://docs.meteor.com/#/full/meteor_users.                                                                    //
//                                                                                                                     //
// There are two distinct types of entries in the users collection: identities and accounts. An                        //
// identity contains personal profile information and typically includes some intrinsic method for                     //
// authenticating as the owner of that information.                                                                    //
//                                                                                                                     //
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                           //
// Each account can have multiple identities linked to it. To log in as an account you must first                      //
// authenticate as one of its linked identities.                                                                       //
//                                                                                                                     //
// Every user contains the following fields:                                                                           //
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                         //
//        stable SHA-256 ID of this identity, hex-encoded.                                                             //
//   createdAt: Date when this entry was added to the collection.                                                      //
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                                //
//   services: Object containing login data used by Meteor authentication services.                                    //
//   expires: Date when this user should be deleted. Only present for demo users.                                      //
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                        //
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                   //
//                     rather than as a Date object. We should fix that.                                               //
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                     //
//              link. This field contains the app ID of the app that the user started out demoing.                     //
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                      //
//              being a demo user.                                                                                     //
//   suspended: If this exists, this account/identity is supsended. Both accounts and identities                       //
//              can be suspended. After some amount of time, the user will be completely deleted                       //
//              and removed from the DB.                                                                               //
//              It is an object with fields:                                                                           //
//                voluntary: Boolean. This is true if the user initiated it. They will have the                        //
//                  chance to still login and reverse the suspension/deletion.                                         //
//                admin: The userId of the admin who suspended the account.                                            //
//                timestamp: Date object. When the suspension occurred.                                                //
//                willDelete: Boolean. If true, this account will be deleted after some time.                          //
//                                                                                                                     //
// Identity users additionally contain the following fields:                                                           //
//   profile: Object containing the data that will be shared with users and grains that come into                      //
//            contact with this identity. Includes the following fields:                                               //
//       service: String containing the name of this identity's authentication method.                                 //
//       name: String containing the chosen display name of the identity.                                              //
//       handle: String containing the identity's preferred handle.                                                    //
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                          //
//                an identicon will be used.                                                                           //
//       pronoun: One of "male", "female", "neutral", or "robot".                                                      //
//   unverifiedEmail: If present, a string containing an email address specified by the user.                          //
//   referredBy: ID of the Account that referred this Identity.                                                        //
//                                                                                                                     //
// Account users additionally contain the following fields:                                                            //
//   loginIdentities: Array of identity objects, each of which may include the following fields.                       //
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                             //
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                      //
//                       a separate array here so that we can use a Mongo index to enforce the                         //
//                       invariant that an identity only be a login identity for a single account.                     //
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                   //
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                        //
//                 to do this checking automatically.                                                                  //
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                  //
//   signupKey: If this is an invited user, then this field contains their signup key.                                 //
//   signupNote: If the user was invited through a link, then this field contains the note that the                    //
//               inviter admin attached to the key.                                                                    //
//   signupEmail: If the user was invited by email, then this field contains the email address that                    //
//                the invite was sent to.                                                                              //
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                    //
//                       terms of service.                                                                             //
//   plan: _id of an entry in the Plans table which determines the user's quota.                                       //
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                       //
//              module writes data here; we merely read it. Missing fields should be treated as                        //
//              zeroes. Does not yet include referral bonus, which is calculated separately.                           //
//              TODO(cleanup): Use for referral bonus too.                                                             //
//   storageUsage: Number of bytes this user is currently storing.                                                     //
//   payments: Object defined by payments module, if loaded.                                                           //
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                 //
//   accessRequests: Object containing the following fields; used to limit spam.                                       //
//       count: Number of "request access" emails during sent during the current interval.                             //
//       resetOn: Date when the count should be reset.                                                                 //
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                              //
//                        stop writing new referredBy values onto Identities for this account.                         //
//   referredCompleteDate: The Date at which the completed referral occurred.                                          //
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                        //
//                        reliably determining which Identity's names are safe to display.                             //
//   experiments: Object where each field is an experiment that the user is in, and each value                         //
//           is the parameters for that experiment. Typically, the value simply names which                            //
//           experiment group which the user is in, where "control" is one group. If an experiment                     //
//           is not listed, then the user should not be considered at all for the purpose of that                      //
//           experiment. Each experiment may define a point in time where users not already in the                     //
//           experiment may be added to it and assigned to a group (for example, at user creation                      //
//           time). Current experiments:                                                                               //
//       firstTimeBillingPrompt: Value is "control" or "test". Users are assigned to groups at                         //
//               account creation on servers where billing is enabled (i.e. Oasis). Users in the                       //
//               test group will see a plan selection dialog and asked to make an explitic choice                      //
//               (possibly "free") before they can create grains (but not when opening someone                         //
//               else's shared grain). The goal of the experiment is to determine whether this                         //
//               prompt scares users away -- and also whether it increases paid signups.                               //
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                       //
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                              //
                                                                                                                       //
Meteor.users.ensureIndexOnServer("services.google.email", { sparse: 1 });                                              // 135
Meteor.users.ensureIndexOnServer("services.github.emails.email", { sparse: 1 });                                       // 136
Meteor.users.ensureIndexOnServer("services.email.email", { unique: 1, sparse: 1 });                                    // 137
Meteor.users.ensureIndexOnServer("loginIdentities.id", { unique: 1, sparse: 1 });                                      // 138
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", { sparse: 1 });                                              // 139
Meteor.users.ensureIndexOnServer("services.google.id", { unique: 1, sparse: 1 });                                      // 140
Meteor.users.ensureIndexOnServer("services.github.id", { unique: 1, sparse: 1 });                                      // 141
Meteor.users.ensureIndexOnServer("suspended.willDelete", { sparse: 1 });                                               // 142
                                                                                                                       //
// TODO(cleanup): This index is obsolete; delete it.                                                                   //
Meteor.users.ensureIndexOnServer("identities.id", { unique: 1, sparse: 1 });                                           // 145
                                                                                                                       //
Packages = new Mongo.Collection("packages");                                                                           // 147
// Packages which are installed or downloading.                                                                        //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                    //
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                   //
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                                //
//       >1 = download byte count.                                                                                     //
//   error:  If status is "failed", error message string.                                                              //
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                          //
//   appId:  If status is "ready", the application ID string.  Packages representing different                         //
//       versions of the same app have the same appId.  The spk tool defines the app ID format                         //
//       and can cryptographically verify that a package belongs to a particular app ID.                               //
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                        //
//       collector should at some point check whether there are any other references and, if not,                      //
//       delete the package.                                                                                           //
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                         //
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                    //
//     even if it has no users.                                                                                        //
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                           //
//     packager.                                                                                                       //
                                                                                                                       //
DevPackages = new Mongo.Collection("devpackages");                                                                     // 169
// List of packages currently made available via the dev tools running on the local machine.                           //
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                     //
// on the local machine to publish an under-development app to this server. That should only ever                      //
// happen on developers' desktop machines.                                                                             //
//                                                                                                                     //
// While a dev package is published, it automatically appears as installed by every user of the                        //
// server, and it overrides all packages with the same application ID. If any instances of those                       //
// packages are currently open, they are killed and reset on publish.                                                  //
//                                                                                                                     //
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                     //
// are again killed and refreshed.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  The package ID string (as with Packages._id).                                                               //
//   appId: The app ID this package is intended to override (as with Packages.appId).                                  //
//   timestamp:  Time when the package was last updated. If this changes while the package is                          //
//     published, all running instances are reset. This is used e.g. to reset the app each time                        //
//     changes are made to the source code.                                                                            //
//   manifest:  The app's manifest, as with Packages.manifest.                                                         //
                                                                                                                       //
UserActions = new Mongo.Collection("userActions");                                                                     // 190
// List of actions that each user has installed which create new grains.  Each app may install                         //
// some number of actions (usually, one).                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   userId:  Account ID of the user who has installed this action.                                                    //
//   packageId:  Package used to run this action.                                                                      //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                 //
//       that clients can access it without subscribing to the Packages collection.                                    //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                               //
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                     //
//       `{defaultText: "New Spreadsheet"}`.                                                                           //
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                        //
//   command:  Manifest.Command to run this action (see package.capnp).                                                //
                                                                                                                       //
Grains = new Mongo.Collection("grains");                                                                               // 209
// Grains belonging to users.                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   packageId:  _id of the package of which this grain is an instance.                                                //
//   packageSalt: If present, a random string that will used in session ID generation. This field                      //
//       is usually updated when `packageId` is updated, triggering automatic refreshes for                            //
//       clients with active sessions.                                                                                 //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   userId: The _id of the account that owns this grain.                                                              //
//   identityId: The identity with which the owning account prefers to open this grain.                                //
//   title:  Human-readable string title, as chosen by the user.                                                       //
//   lastUsed:  Date when the grain was last used by a user.                                                           //
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                    //
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                    //
//                   time a session to this grain was opened.                                                          //
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                       //
//            this date, the grain will be automatically deleted.                                                      //
//   suspended: If true, the owner of this grain has been suspended. They will soon be deleted,                        //
//              so treat this grain the same as "trashed". It is denormalized out of Users for ease                    //
//              of querying.                                                                                           //
//   ownerSeenAllActivity: True if the owner has viewed the grain since the last activity event                        //
//       occurred. See also ApiTokenOwner.user.seenAllActivity.                                                        //
//   size: On-disk size of the grain in bytes.                                                                         //
//                                                                                                                     //
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                     //
// web publishing functionality without powerbox support; they will be replaced once the powerbox                      //
// is implemented.                                                                                                     //
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                     //
//       web publishing. This field is initialized when first requested by the app.                                    //
                                                                                                                       //
RoleAssignments = new Mongo.Collection("roleAssignments");                                                             // 243
// *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges                    //
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                             //
// collection.                                                                                                         //
                                                                                                                       //
Contacts = new Mongo.Collection("contacts");                                                                           // 248
// Edges in the social graph.                                                                                          //
//                                                                                                                     //
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                         //
// will show up in her user-picker UI for actions like share-by-identity.                                              //
//                                                                                                                     //
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                        //
// Bob's.                                                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: random                                                                                                       //
//   ownerId: The accountId of the user account who owns this contact.                                                 //
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                        //
//            the contact to the owner.                                                                                //
//   created: Date when this contact was created.                                                                      //
//   identityId: The `_id` of the user whose contact info this contains.                                               //
                                                                                                                       //
Sessions = new Mongo.Collection("sessions");                                                                           // 265
// UI sessions open to particular grains.  A new session is created each time a user opens a grain.                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  String generated as a SHA256 hash of the grain ID, the user ID, a salt generated by the                     //
//       client, and the grain's `packageSalt`.                                                                        //
//   grainId:  _id of the grain to which this session is connected.                                                    //
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                     //
//       '*' in WILDCARD_HOST.                                                                                         //
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                         //
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                      //
//       have the same `tabId` as the outer session.                                                                   //
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                        //
//       period.                                                                                                       //
//   userId:  Account ID of the user who owns this session.                                                            //
//   identityId:  Identity ID of the user who owns this session.                                                       //
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                      //
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                         //
//       anonymous users can get access without an API token and so neither userId nor hashedToken                     //
//       are present.                                                                                                  //
//   powerboxView: If present, this is a view that should be presented as part of a powerbox                           //
//       interaction.                                                                                                  //
//     offer: The webkey that corresponds to cap that was passed to the `offer` RPC.                                   //
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                     //
//       until newSession is called on the UiView.                                                                     //
//   permissions: The permissions for the current identity on this UiView. This isn't populated                        //
//       until newSession is called on the UiView.                                                                     //
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                   //
//       request                                                                                                       //
                                                                                                                       //
SignupKeys = new Mongo.Collection("signupKeys");                                                                       // 295
// Invite keys which may be used by users to get access to Sandstorm.                                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   used:  Boolean indicating whether this key has already been consumed.                                             //
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                          //
//   email: If this key was sent as an email invite, the email address to which it was sent.                           //
                                                                                                                       //
ActivityStats = new Mongo.Collection("activityStats");                                                                 // 304
// Contains usage statistics taken on a regular interval. Each entry is a data point.                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   timestamp: Date when measurements were taken.                                                                     //
//   daily: Contains stats counts pertaining to the last day before the sample time.                                   //
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                           //
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                           //
//                                                                                                                     //
// Each of daily, weekly, and monthly contains:                                                                        //
//   activeUsers: The number of unique users who have used a grain on the server in the time                           //
//       interval. Only counts logged-in users.                                                                        //
//   demoUsers: Demo users.                                                                                            //
//   appDemoUsers: Users that came in through "app demo".                                                              //
//   activeGrains: The number of unique grains that have been used in the time interval.                               //
//   apps: An object indexed by app ID recording, for each app:                                                        //
//       owners: Number of unique owners of this app (counting only grains that still exist).                          //
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                    //
//         only grains that still exist).                                                                              //
//       grains: Number of active grains of this app (that still exist).                                               //
//       deleted: Number of non-demo grains of this app that were deleted.                                             //
//       demoed: Number of demo grains created and expired.                                                            //
//       appDemoUsers: Number of app demos initiated with this app.                                                    //
                                                                                                                       //
DeleteStats = new Mongo.Collection("deleteStats");                                                                     // 328
// Contains records of objects that were deleted, for stat-keeping purposes.                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                             //
//   lastActive: Date of the user's or grain's last activity.                                                          //
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                     //
//     arrived to demo. For others, undefined.                                                                         //
                                                                                                                       //
FileTokens = new Mongo.Collection("fileTokens");                                                                       // 337
// Tokens corresponding to backup files that are currently stored on the server. A user receives                       //
// a token when they create a backup file (either by uploading it, or by backing up one of their                       //
// grains) and may use the token to read the file (either to download it, or to restore a new                          //
// grain from it).                                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The unguessable token string.                                                                          //
//   name:      Suggested filename.                                                                                    //
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                        //
                                                                                                                       //
ApiTokens = new Mongo.Collection("apiTokens");                                                                         // 348
// Access tokens for APIs exported by apps.                                                                            //
//                                                                                                                     //
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                      //
// now they are also used to implement SturdyRefs, not just held by external users, but also when                      //
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                           //
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                         //
// `MainView`) -- the fields of type `Data` are API tokens.                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                           //
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                      //
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                       //
//              That is, the UiView's newSession() method will intersect the requested permissions                     //
//              with this identity's permissions before forwarding on to the underlying app. If                        //
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                     //
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                        //
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                     //
//              this is NOT the identity against which the `requiredPermissions` parameter of                          //
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                   //
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                    //
//              that created the token.                                                                                //
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                         //
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                    //
//              permissions will be intersected with those held by `identityId` when the view is                       //
//              opened.                                                                                                //
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                    //
//              anonymous rather than as directly associated with `identityId`. This has no effect                     //
//              on the permissions granted.                                                                            //
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                      //
//              the app or its supervisor (whereas without this it strictly represents UiView).                        //
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                      //
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                             //
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                               //
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                    //
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                    //
//              containing exactly one of the following fields:                                                        //
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                    //
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                           //
//                           `Notifications` collection.                                                               //
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                      //
//                  will be moved out of the frontend and into the backend, but we'll migrate the                      //
//                  database when that happens. This field contains the boolean true to signify that                   //
//                  it has been set.                                                                                   //
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                     //
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                           //
//                      value is an object containing the fields `id` and `services`. `id` is the                      //
//                      value returned by `EmailVerifier.getId()` and is used as part of a                             //
//                      powerbox query for matching verified emails. `services` is a                                   //
//                      list of names of identity providers that are trusted to verify addresses.                      //
//                      If `services` is omitted or falsy, all configured identity providers are                       //
//                      trusted. Note that a malicious user could specify invalid names in the                         //
//                      list; they should be ignored.                                                                  //
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                               //
//                      An object containing `verifierId`, `tabId`, and `address`.                                     //
//       identity: An Identity capability. The field is the identity ID.                                               //
//   parentToken: If present, then this token represents exactly the capability represented by                         //
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                    //
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                       //
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                       //
//              is set to the identity that shared the view, and `accountId` is set to the account                     //
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                             //
//              `parentToken` is present.                                                                              //
//   petname:   Human-readable label for this access token, useful for identifying tokens for                          //
//              revocation. This should be displayed when visualizing incoming capabilities to                         //
//              the grain identified by `grainId`.                                                                     //
//   created:   Date when this token was created.                                                                      //
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                    //
//              become un-revoked in the future.                                                                       //
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                     //
//              this date, the token will be automatically deleted.                                                    //
//   suspended: If true, the owner of this token has been suspended. They will soon be deleted,                        //
//              so treat this token the same as "trashed". It is denormalized out of Users for                         //
//              ease of querying.                                                                                      //
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                     //
//   lastUsed:  Optional Date when this token was last used.                                                           //
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                             //
//              as passed to the `save()` call that created this token. If not present, treat                          //
//              as `webkey` (the default for `ApiTokenOwner`).                                                         //
//   expiresIfUnused:                                                                                                  //
//              Optional Date after which the token, if it has not been used yet, expires.                             //
//              This field should be cleared on a token's first use.                                                   //
//   requirements: List of conditions which must hold for this token to be considered valid.                           //
//              Semantically, this list specifies the powers which were *used* to originally                           //
//              create the token. If any condition in the list becomes untrue, then the token must                     //
//              be considered revoked, and all live refs and sturdy refs obtained transitively                         //
//              through it must also become revoked. Each item is the JSON serialization of the                        //
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                         //
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                          //
//              cleaned up when the token is.                                                                          //
//                                                                                                                     //
// It is important to note that a token's owner and provider are independent from each other. To                       //
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                    //
//                                                                                                                     //
// struct ApiToken {                                                                                                   //
//   owner :ApiTokenOwner;                                                                                             //
//   provider :union {                                                                                                 //
//     grain :group {                                                                                                  //
//       grainId :Text;                                                                                                //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment;                                                                           //
//           forSharing :Bool;                                                                                         //
//         }                                                                                                           //
//         objectId :SupervisorObjectId;                                                                               //
//       }                                                                                                             //
//     }                                                                                                               //
//     frontendRef :union {                                                                                            //
//       notificationHandle :Text;                                                                                     //
//       ipNetwork :Bool;                                                                                              //
//       ipInterface :Bool;                                                                                            //
//       emailVerifier :group {                                                                                        //
//         id :Text;                                                                                                   //
//         services :List(String);                                                                                     //
//       }                                                                                                             //
//       verifiedEmail :group {                                                                                        //
//         verifierId :Text;                                                                                           //
//         tabId :Text;                                                                                                //
//         address :Text;                                                                                              //
//       }                                                                                                             //
//       identity :Text;                                                                                               //
//     }                                                                                                               //
//     child :group {                                                                                                  //
//       parentToken :Text;                                                                                            //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           grainId :Text;                                                                                            //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment = (allAccess = ());                                                        //
//         }                                                                                                           //
//         other :Void;                                                                                                //
//       }                                                                                                             //
//     }                                                                                                               //
//   }                                                                                                                 //
//   requirements: List(Supervisor.MembraneRequirement);                                                               //
//   ...                                                                                                               //
// }                                                                                                                   //
                                                                                                                       //
ApiTokens.ensureIndexOnServer("grainId", { sparse: 1 });                                                               // 487
ApiTokens.ensureIndexOnServer("owner.user.identityId", { sparse: 1 });                                                 // 488
ApiTokens.ensureIndexOnServer("frontendRef.emailVerifier.id", { sparse: 1 });                                          // 489
                                                                                                                       //
ApiHosts = new Mongo.Collection("apiHosts");                                                                           // 491
// Allows defining some limited static behavior for an API host when accessed unauthenticated. This                    //
// mainly exists to allow backwards-compatibility with client applications that expect to be able                      //
// to probe an API host without authentication to determine capabilities such as DAV protocols                         //
// supported, before authenticating to perform real requests. An app can specify these properties                      //
// when creating an offerTemplate.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                             //
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                     //
//                 up when ApiTokens are deleted.                                                                      //
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                          //
//                 This is an object containing fields:                                                                //
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                             //
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                 //
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                        //
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                      //
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                          //
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                          //
//                 fields:                                                                                             //
//     type:       Content-Type.                                                                                       //
//     language:   Content-Language.                                                                                   //
//     encoding:   Content-Encoding.                                                                                   //
//     body:       Entity-body as a string or buffer.                                                                  //
                                                                                                                       //
Notifications = new Mongo.Collection("notifications");                                                                 // 516
// Notifications for a user.                                                                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   grainId:      The grain originating this notification, if any.                                                    //
//   userId:       Account ID of the user receiving the notification.                                                  //
//   text:         The JSON-ified LocalizedText to display in the notification.                                        //
//   isUnread:     Boolean indicating if this notification is unread.                                                  //
//   timestamp:    Date when this notification was last updated                                                        //
//   eventType:    If this notification is due to an activity event, this is the numeric index                         //
//                 of the event type on the grain's ViewInfo.                                                          //
//   count:        The number of times this exact event has repeated. Identical events are                             //
//                 aggregated by incrementing the count.                                                               //
//   initiatingIdentity: Identity ID of the user who initiated this notification.                                      //
//   path:         Path inside the grain to which the user should be directed if they click on                         //
//                 the notification.                                                                                   //
//   ongoing:      If present, this is an ongoing notification, and this field contains an                             //
//                 ApiToken referencing the `OngoingNotification` capability.                                          //
//   admin:        If present, this is a notification intended for an admin.                                           //
//     action:     If present, this is a (string) link that the notification should direct the                         //
//                 admin to.                                                                                           //
//     type:       The type of notification (currently only "reportStats").                                            //
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                     //
//                 as keys.                                                                                            //
//     $appId:     The appId that has an outstanding update.                                                           //
//       packageId: The packageId that it will update to.                                                              //
//       name: The name of the app. (appTitle from package.manifest)                                                   //
//       version: The app's version number. (appVersion from package.manifest)                                         //
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)           //
//   referral:     If this boolean field is true, then treat this notification as a referral                           //
//                 notification. This causes text to be ignored, since we need custom logic.                           //
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                      //
//                 a one-time notification only to Oasis users who existed when the bonus program                      //
//                 was implemented.                                                                                    //
                                                                                                                       //
ActivitySubscriptions = new Mongo.Collection("activitySubscriptions");                                                 // 552
// Activity events to which a user is subscribed.                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   identityId:   Who is subscribed.                                                                                  //
//   grainId:      Grain to which subscription applies.                                                                //
//   threadPath:   If present, the subscription is on a specific thread. Otherwise, it is on the                       //
//                 whole grain.                                                                                        //
//   mute:         If true, this is an anti-subscription -- matching events should NOT notify.                         //
//                 This allows is useful to express:                                                                   //
//                 - A user wants to subscribe to a grain but mute a specific thread.                                  //
//                 - The owner of a grain does not want notifications (normally, they are                              //
//                   implicitly subscribed).                                                                           //
//                 - A user no longer wishes to be implicitly subscribed to threads in a grain on                      //
//                   which they comment, so they mute the grain.                                                       //
                                                                                                                       //
ActivitySubscriptions.ensureIndexOnServer("identityId");                                                               // 569
ActivitySubscriptions.ensureIndexOnServer({ "grainId": 1, "threadPath": 1 });                                          // 570
                                                                                                                       //
StatsTokens = new Mongo.Collection("statsTokens");                                                                     // 572
// Access tokens for the Stats collection                                                                              //
//                                                                                                                     //
// These tokens are used for accessing the ActivityStats collection remotely                                           //
// (ie. from a dashboard webapp)                                                                                       //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                  //
                                                                                                                       //
Misc = new Mongo.Collection("misc");                                                                                   // 581
// Miscellaneous configuration and other settings                                                                      //
//                                                                                                                     //
// This table is currently only used for persisting BASE_URL from one session to the next,                             //
// but in general any miscellaneous settings should go in here                                                         //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "BASE_URL"                                                                //
//   value:     The value of the setting.                                                                              //
                                                                                                                       //
Settings = new Mongo.Collection("settings");                                                                           // 591
// Settings for this Sandstorm instance go here. They are configured through the adminSettings                         //
// route. This collection differs from misc in that any admin user can update it through the admin                     //
// interface.                                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "smtpConfig"                                                              //
//   value:     The value of the setting.                                                                              //
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                     //
//                       so, it will also write an object to this field indicating why the reset was                   //
//                       needed. That object can have the following variants:                                          //
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                      //
//                           with the old BASE_URL.                                                                    //
//   preinstalledApps: A list of objects:                                                                              //
//     appId: The Packages.appId of the app to install                                                                 //
//     status: packageId                                                                                               //
//     packageId: The Packages._id of the app to install                                                               //
//                                                                                                                     //
//   potentially other fields that are unique to the setting                                                           //
                                                                                                                       //
Migrations = new Mongo.Collection("migrations");                                                                       // 611
// This table tracks which migrations we have applied to this instance.                                                //
// It contains a single entry:                                                                                         //
//   _id:       "migrations_applied"                                                                                   //
//   value:     The number of migrations this instance has successfully completed.                                     //
                                                                                                                       //
StaticAssets = new Mongo.Collection("staticAssets");                                                                   // 617
// Collection of static assets served up from the Sandstorm server's "static" host. We only                            //
// support relatively small assets: under 1MB each.                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID; will be used in the URL.                                                                    //
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                            //
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                              //
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                    //
//   content:   The asset content (byte buffer).                                                                       //
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                    //
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                        //
//       to catch leaked assets, although it's probably not a big deal in practice.                                    //
                                                                                                                       //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens");                                                         // 631
// Collection of tokens representing a single-use permission to upload an asset, such as a new                         //
// profile picture.                                                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID.                                                                                             //
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                 //
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                          //
//           userId: Account ID of user whose picture shall be replaced.                                               //
//           identityId: Which of the user's identities shall be updated.                                              //
//   expires:   Time when this token will go away if unused.                                                           //
                                                                                                                       //
Plans = new Mongo.Collection("plans");                                                                                 // 643
// Subscription plans, which determine quota.                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                                //
//   storage: Number of bytes this user is allowed to store.                                                           //
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                          //
//   computeLabel: Label to display to the user describing this plan's compute units.                                  //
//   grains: Total number of grains this user can create (often `Infinity`).                                           //
//   price: Price per month in US cents.                                                                               //
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                           //
//       allowed to switch away.                                                                                       //
//   title: Title from display purposes. If missing, default to capitalizing _id.                                      //
                                                                                                                       //
AppIndex = new Mongo.Collection("appIndex");                                                                           // 657
// A mirror of the data from the App Market index                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: the appId of the app                                                                                         //
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                    //
                                                                                                                       //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles");                                                             // 664
// Cache of Keybase profile information. The profile for a user is re-fetched every time a package                     //
// by that user is installed, as well as if the keybase profile is requested and not already                           //
// present for some reason.                                                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                   //
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                    //
//   handle: Keybase handle.                                                                                           //
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                      //
//     docs for details. We also add a boolean "status" field to each proof indicating whether                         //
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                          //
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                     //
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                     //
//     server is currently actively checking this proof). Note that if a check fails due to network                    //
//     errors, the status goes back to "unverified".                                                                   //
//                                                                                                                     //
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                          //
//       for now and we just trust Keybase.                                                                            //
                                                                                                                       //
FeatureKey = new Mongo.Collection("featureKey");                                                                       // 684
// Responsible for storing the current feature key that is active on the server.  Contains a single                    //
// document with two keys:                                                                                             //
//                                                                                                                     //
//   _id: "currentFeatureKey"                                                                                          //
//   value: the still-signed, binary-encoded feature key                                                               //
//          (a feature key with comments removed and base64 decoded)                                                   //
//                                                                                                                     //
// This is only intended to be visible on the server.                                                                  //
                                                                                                                       //
SetupSession = new Mongo.Collection("setupSession");                                                                   // 694
// Responsible for storing information about setup sessions.  Contains a single document with three                    //
// keys:                                                                                                               //
//                                                                                                                     //
//   _id: "current-session"                                                                                            //
//   creationDate: Date object indicating when this session was created.                                               //
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                              //
                                                                                                                       //
var DesktopNotifications = new Mongo.Collection("desktopNotifications");                                               // 702
// Responsible for very short-lived queueing of desktop notification information.                                      //
// Entries are removed when they are ~30 seconds old.  This collection is a bit                                        //
// odd in that it is intended primarily for edge-triggered communications, but                                         //
// Meteor's collections aren't really designed to support that organization.                                           //
// Fields for each :                                                                                                   //
//                                                                                                                     //
//   _id: String.  Used as the tag to coordinate notification merging between browser tabs.                            //
//   creationDate: Date object. indicating when this notification was posted.                                          //
//   userId: String. Account id to which this notification was published.                                              //
//   notificationId: String.  ID of the matching event in the Notifications table to dismiss if this                   //
//                            notification is activated.                                                               //
//   appActivity: Object with fields:                                                                                  //
//     user: {               The user whose action caused this notification.                                           //
//       name: String,       The user's display name.                                                                  //
//       avatarUrl: String,  The URL for the user's profile picture.                                                   //
//     },                                                                                                              //
//     grainId: String,      Which grain this action took place on                                                     //
//     path: String,         The path of the notification.                                                             //
//     body: Util.LocalizedText,  The main body of the activity event.                                                 //
//     actionText: Util.LocalizedText, What action the user took, e.g.                                                 //
//                                     { defaultText: "added a comment" }                                              //
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 725
  Meteor.publish("credentials", function () {                                                                          // 726
    // Data needed for isSignedUp() and isAdmin() to work.                                                             //
                                                                                                                       //
    if (this.userId) {                                                                                                 // 729
      return [Meteor.users.find({ _id: this.userId }, { fields: { signupKey: 1, isAdmin: 1, expires: 1, storageUsage: 1,
          plan: 1, planBonus: 1, hasCompletedSignup: 1, experiments: 1,                                                // 733
          referredIdentityIds: 1, cachedStorageQuota: 1, suspended: 1 } }), Plans.find()];                             // 734
    } else {                                                                                                           // 737
      return [];                                                                                                       // 738
    }                                                                                                                  // 739
  });                                                                                                                  // 740
}                                                                                                                      // 741
                                                                                                                       //
var countReferrals = function countReferrals(user) {                                                                   // 743
  var referredIdentityIds = user.referredIdentityIds;                                                                  // 744
  return referredIdentityIds && referredIdentityIds.length || 0;                                                       // 745
};                                                                                                                     // 746
                                                                                                                       //
var calculateReferralBonus = function calculateReferralBonus(user) {                                                   // 748
  // This function returns an object of the form:                                                                      //
  //                                                                                                                   //
  // - {grains: 0, storage: 0}                                                                                         //
  //                                                                                                                   //
  // which are extra resources this account gets as part of participating in the referral                              //
  // program. (Storage is measured in bytes, as usual for plans.)                                                      //
                                                                                                                       //
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                        //
  //   payments-specific) and aggregating into `planBonus`.                                                            //
                                                                                                                       //
  // Authorization note: Only call this if accountId is the current user!                                              //
  var isPaid = user.plan && user.plan !== "free";                                                                      // 760
                                                                                                                       //
  successfulReferralsCount = countReferrals(user);                                                                     // 762
  if (isPaid) {                                                                                                        // 763
    var maxPaidStorageBonus = 30 * 1e9;                                                                                // 764
    return { grains: 0,                                                                                                // 765
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus) };                                    // 766
  } else {                                                                                                             // 769
    var maxFreeStorageBonus = 2 * 1e9;                                                                                 // 770
    var bonus = {                                                                                                      // 771
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                      // 772
    };                                                                                                                 // 771
    if (successfulReferralsCount > 0) {                                                                                // 776
      bonus.grains = Infinity;                                                                                         // 777
    } else {                                                                                                           // 778
      bonus.grains = 0;                                                                                                // 779
    }                                                                                                                  // 780
                                                                                                                       //
    return bonus;                                                                                                      // 782
  }                                                                                                                    // 783
};                                                                                                                     // 784
                                                                                                                       //
isAdmin = function isAdmin() {                                                                                         // 786
  // Returns true if the user is the administrator.                                                                    //
                                                                                                                       //
  var user = Meteor.user();                                                                                            // 789
  if (user && user.isAdmin) {                                                                                          // 790
    return true;                                                                                                       // 791
  } else {                                                                                                             // 792
    return false;                                                                                                      // 793
  }                                                                                                                    // 794
};                                                                                                                     // 795
                                                                                                                       //
isAdminById = function isAdminById(id) {                                                                               // 797
  // Returns true if the user's id is the administrator.                                                               //
                                                                                                                       //
  var user = Meteor.users.findOne({ _id: id }, { fields: { isAdmin: 1 } });                                            // 800
  if (user && user.isAdmin) {                                                                                          // 801
    return true;                                                                                                       // 802
  } else {                                                                                                             // 803
    return false;                                                                                                      // 804
  }                                                                                                                    // 805
};                                                                                                                     // 806
                                                                                                                       //
findAdminUserForToken = function findAdminUserForToken(token) {                                                        // 808
  if (!token.requirements) {                                                                                           // 809
    return;                                                                                                            // 810
  }                                                                                                                    // 811
                                                                                                                       //
  var requirements = token.requirements.filter(function (requirement) {                                                // 813
    return "userIsAdmin" in requirement;                                                                               // 814
  });                                                                                                                  // 815
                                                                                                                       //
  if (requirements.length > 1) {                                                                                       // 817
    return;                                                                                                            // 818
  }                                                                                                                    // 819
                                                                                                                       //
  if (requirements.length === 0) {                                                                                     // 821
    return;                                                                                                            // 822
  }                                                                                                                    // 823
                                                                                                                       //
  return requirements[0].userIsAdmin;                                                                                  // 825
};                                                                                                                     // 826
                                                                                                                       //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 828
                                                                                                                       //
if (wildcardHost.length != 2) {                                                                                        // 830
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                 // 831
}                                                                                                                      // 832
                                                                                                                       //
matchWildcardHost = function matchWildcardHost(host) {                                                                 // 834
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                           //
                                                                                                                       //
  // We remove everything after the first ":" character so that our                                                    //
  // comparison logic ignores port numbers.                                                                            //
  var prefix = wildcardHost[0];                                                                                        // 839
  var suffix = wildcardHost[1].split(":")[0];                                                                          // 840
  var hostSansPort = host.split(":")[0];                                                                               // 841
                                                                                                                       //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                        // 846
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                    // 847
      return id;                                                                                                       // 848
    }                                                                                                                  // 849
  }                                                                                                                    // 850
                                                                                                                       //
  return null;                                                                                                         // 852
};                                                                                                                     // 853
                                                                                                                       //
makeWildcardHost = function makeWildcardHost(id) {                                                                     // 855
  return wildcardHost[0] + id + wildcardHost[1];                                                                       // 856
};                                                                                                                     // 857
                                                                                                                       //
var isApiHostId = function isApiHostId(hostId) {                                                                       // 859
  if (hostId) {                                                                                                        // 860
    var split = hostId.split("-");                                                                                     // 861
    if (split[0] === "api") return split[1] || "*";                                                                    // 862
  }                                                                                                                    // 863
                                                                                                                       //
  return false;                                                                                                        // 865
};                                                                                                                     // 866
                                                                                                                       //
var isTokenSpecificHostId = function isTokenSpecificHostId(hostId) {                                                   // 868
  return hostId.lastIndexOf("api-", 0) === 0;                                                                          // 869
};                                                                                                                     // 870
                                                                                                                       //
var apiHostIdHashForToken = void 0;                                                                                    // 872
if (Meteor.isServer) {                                                                                                 // 873
  (function () {                                                                                                       // 873
    var Crypto = Npm.require("crypto");                                                                                // 874
    apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                    // 875
      // Given an API token, compute the host ID that must be used when requesting this token.                         //
                                                                                                                       //
      // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                      //
      // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                     //
      // of tokens). This doesn't technically add any security, but helps prove that we don't have                     //
      // any bugs which would allow someone who knows only the hostname to access the app API.                         //
      return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                               // 882
    };                                                                                                                 // 883
  })();                                                                                                                // 873
} else {                                                                                                               // 884
  apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                      // 885
    // Given an API token, compute the host ID that must be used when requesting this token.                           //
                                                                                                                       //
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        //
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       //
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       //
    // any bugs which would allow someone who knows only the hostname to access the app API.                           //
    return SHA256("x" + token).slice(0, 32);                                                                           // 892
  };                                                                                                                   // 893
}                                                                                                                      // 894
                                                                                                                       //
var apiHostIdForToken = function apiHostIdForToken(token) {                                                            // 896
  return "api-" + apiHostIdHashForToken(token);                                                                        // 897
};                                                                                                                     // 898
                                                                                                                       //
var makeApiHost = function makeApiHost(token) {                                                                        // 900
  return makeWildcardHost(apiHostIdForToken(token));                                                                   // 901
};                                                                                                                     // 902
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 904
  (function () {                                                                                                       // 904
    var Url = Npm.require("url");                                                                                      // 905
    getWildcardOrigin = function getWildcardOrigin() {                                                                 // 906
      // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                      //
      // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                    //
      // an astrisk is only allowed as the first character and must be followed by a period. So we need                //
      // "*.example.com" instead -- which matches more than we actually want, but is the best we can                   //
      // really do. We also add the protocol to the front (again, that's what CSP wants).                              //
                                                                                                                       //
      // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                 //
      var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                         // 914
                                                                                                                       //
      var dotPos = wildcardHost[1].indexOf(".");                                                                       // 916
      if (dotPos < 0) {                                                                                                // 917
        return protocol + "//*";                                                                                       // 918
      } else {                                                                                                         // 919
        return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                       // 920
      }                                                                                                                // 921
    };                                                                                                                 // 922
  })();                                                                                                                // 904
}                                                                                                                      // 923
                                                                                                                       //
allowDevAccounts = function allowDevAccounts() {                                                                       // 925
  var setting = Settings.findOne({ _id: "devAccounts" });                                                              // 926
  if (setting) {                                                                                                       // 927
    return setting.value;                                                                                              // 928
  } else {                                                                                                             // 929
    return Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDevAccounts;                 // 930
  }                                                                                                                    // 932
};                                                                                                                     // 933
                                                                                                                       //
sendReferralProgramNotification = function sendReferralProgramNotification(userId) {                                   // 935
  Notifications.upsert({                                                                                               // 936
    userId: userId,                                                                                                    // 937
    referral: true                                                                                                     // 938
  }, {                                                                                                                 // 936
    userId: userId,                                                                                                    // 940
    referral: true,                                                                                                    // 941
    timestamp: new Date(),                                                                                             // 942
    isUnread: true                                                                                                     // 943
  });                                                                                                                  // 939
};                                                                                                                     // 945
                                                                                                                       //
roleAssignmentPattern = {                                                                                              // 947
  none: Match.Optional(null),                                                                                          // 948
  allAccess: Match.Optional(null),                                                                                     // 949
  roleId: Match.Optional(Match.Integer),                                                                               // 950
  addPermissions: Match.Optional([Boolean]),                                                                           // 951
  removePermissions: Match.Optional([Boolean])                                                                         // 952
};                                                                                                                     // 947
                                                                                                                       //
SandstormDb = function SandstormDb(quotaManager) {                                                                     // 955
  // quotaManager is an object with the following method:                                                              //
  //   updateUserQuota: It is provided two arguments                                                                   //
  //     db: This SandstormDb object                                                                                   //
  //     user: A collections.users account object                                                                      //
  //   and returns a quota object:                                                                                     //
  //     storage: A number (can be Infinity)                                                                           //
  //     compute: A number (can be Infinity)                                                                           //
  //     grains: A number (can be Infinity)                                                                            //
                                                                                                                       //
  this.quotaManager = quotaManager;                                                                                    // 965
  this.collections = {                                                                                                 // 966
    // Direct access to underlying collections. DEPRECATED, but better than accessing the top-level                    //
    // collection globals directly.                                                                                    //
    //                                                                                                                 //
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                      //
    //   direct access to the collections.                                                                             //
    users: Meteor.users,                                                                                               // 972
                                                                                                                       //
    packages: Packages,                                                                                                // 974
    devPackages: DevPackages,                                                                                          // 975
    userActions: UserActions,                                                                                          // 976
    grains: Grains,                                                                                                    // 977
    roleAssignments: RoleAssignments, // Deprecated, only used by the migration that eliminated it.                    // 978
    contacts: Contacts,                                                                                                // 979
    sessions: Sessions,                                                                                                // 980
    signupKeys: SignupKeys,                                                                                            // 981
    activityStats: ActivityStats,                                                                                      // 982
    deleteStats: DeleteStats,                                                                                          // 983
    fileTokens: FileTokens,                                                                                            // 984
    apiTokens: ApiTokens,                                                                                              // 985
    apiHosts: ApiHosts,                                                                                                // 986
    notifications: Notifications,                                                                                      // 987
    // Omitted: ActivitySubscriptions                                                                                  //
    statsTokens: StatsTokens,                                                                                          // 989
    misc: Misc,                                                                                                        // 990
    settings: Settings,                                                                                                // 991
    migrations: Migrations,                                                                                            // 992
    // Omitted: StaticAssets                                                                                           //
    // Omitted: AssetUploadTokens                                                                                      //
    plans: Plans,                                                                                                      // 995
    appIndex: AppIndex,                                                                                                // 996
    keybaseProfiles: KeybaseProfiles,                                                                                  // 997
    featureKey: FeatureKey,                                                                                            // 998
    setupSession: SetupSession,                                                                                        // 999
    desktopNotifications: DesktopNotifications                                                                         // 1000
  };                                                                                                                   // 966
};                                                                                                                     // 1002
                                                                                                                       //
// TODO(cleanup): These methods should not be defined freestanding and should use collection                           //
//   objects created in SandstormDb's constructor rather than globals.                                                 //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1007
  isAdmin: isAdmin,                                                                                                    // 1008
  isAdminById: isAdminById,                                                                                            // 1009
  findAdminUserForToken: findAdminUserForToken,                                                                        // 1010
  matchWildcardHost: matchWildcardHost,                                                                                // 1011
  makeWildcardHost: makeWildcardHost,                                                                                  // 1012
  isApiHostId: isApiHostId,                                                                                            // 1013
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                        // 1014
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                        // 1015
  apiHostIdForToken: apiHostIdForToken,                                                                                // 1016
  makeApiHost: makeApiHost,                                                                                            // 1017
  allowDevAccounts: allowDevAccounts,                                                                                  // 1018
  roleAssignmentPattern: roleAssignmentPattern,                                                                        // 1019
                                                                                                                       //
  isDemoUser: function isDemoUser() {                                                                                  // 1021
    // Returns true if this is a demo user.                                                                            //
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1024
    if (user && user.expires) {                                                                                        // 1025
      return true;                                                                                                     // 1026
    } else {                                                                                                           // 1027
      return false;                                                                                                    // 1028
    }                                                                                                                  // 1029
  },                                                                                                                   // 1030
                                                                                                                       //
  isSignedUp: function isSignedUp() {                                                                                  // 1032
    var user = Meteor.user();                                                                                          // 1033
    return this.isAccountSignedUp(user);                                                                               // 1034
  },                                                                                                                   // 1035
                                                                                                                       //
  isAccountSignedUp: function isAccountSignedUp(user) {                                                                // 1037
    // Returns true if the user has presented an invite key.                                                           //
                                                                                                                       //
    if (!user) return false; // not signed in                                                                          // 1040
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1042
                                                                                                                       //
    if (user.expires) return false; // demo user.                                                                      // 1044
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1046
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1048
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1050
                                                                                                                       //
    return false;                                                                                                      // 1052
  },                                                                                                                   // 1053
                                                                                                                       //
  isSignedUpOrDemo: function isSignedUpOrDemo() {                                                                      // 1055
    var user = Meteor.user();                                                                                          // 1056
    return this.isAccountSignedUpOrDemo(user);                                                                         // 1057
  },                                                                                                                   // 1058
                                                                                                                       //
  isAccountSignedUpOrDemo: function isAccountSignedUpOrDemo(user) {                                                    // 1060
    if (!user) return false; // not signed in                                                                          // 1061
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1063
                                                                                                                       //
    if (user.expires) return true; // demo user.                                                                       // 1065
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1067
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1069
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1071
                                                                                                                       //
    return false;                                                                                                      // 1073
  },                                                                                                                   // 1074
                                                                                                                       //
  isIdentityInOrganization: function isIdentityInOrganization(identity) {                                              // 1076
    if (!identity || !identity.services) {                                                                             // 1077
      return false;                                                                                                    // 1078
    }                                                                                                                  // 1079
                                                                                                                       //
    var orgMembership = this.getOrganizationMembership();                                                              // 1081
    var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                         // 1082
    var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                           // 1083
    var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;                  // 1084
    var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                    // 1085
    var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                               // 1086
    var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                               // 1087
    if (emailEnabled && emailDomain && identity.services.email) {                                                      // 1088
      if (identity.services.email.email.toLowerCase().split("@").pop() === emailDomain) {                              // 1089
        return true;                                                                                                   // 1090
      }                                                                                                                // 1091
    } else if (ldapEnabled && identity.services.ldap) {                                                                // 1092
      return true;                                                                                                     // 1093
    } else if (samlEnabled && identity.services.saml) {                                                                // 1094
      return true;                                                                                                     // 1095
    } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {             // 1096
      if (identity.services.google.hd.toLowerCase() === googleDomain) {                                                // 1097
        return true;                                                                                                   // 1098
      }                                                                                                                // 1099
    }                                                                                                                  // 1100
                                                                                                                       //
    return false;                                                                                                      // 1102
  },                                                                                                                   // 1103
                                                                                                                       //
  isUserInOrganization: function isUserInOrganization(user) {                                                          // 1105
    if (!this.isFeatureKeyValid()) {                                                                                   // 1106
      return false;                                                                                                    // 1107
    }                                                                                                                  // 1108
                                                                                                                       //
    for (var i = 0; i < user.loginIdentities.length; i++) {                                                            // 1110
      var identity = Meteor.users.findOne({ _id: user.loginIdentities[i].id });                                        // 1111
      if (this.isIdentityInOrganization(identity)) {                                                                   // 1112
        return true;                                                                                                   // 1113
      }                                                                                                                // 1114
    }                                                                                                                  // 1115
                                                                                                                       //
    return false;                                                                                                      // 1117
  }                                                                                                                    // 1118
});                                                                                                                    // 1007
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1121
  (function () {                                                                                                       // 1121
    SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                       // 1122
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1124
    SandstormDb.prototype.removeApiTokens = function (query) {                                                         // 1125
      // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                           //
                                                                                                                       //
      this.collections.apiTokens.find(query).forEach(function (token) {                                                // 1128
        // Clean up ApiHosts for webkey tokens.                                                                        //
        if (token.hasApiHost) {                                                                                        // 1130
          var hash2 = Crypto.createHash("sha256").update(token._id).digest("base64");                                  // 1131
          ApiHosts.remove({ hash2: hash2 });                                                                           // 1132
        }                                                                                                              // 1133
      });                                                                                                              // 1134
                                                                                                                       //
      this.collections.apiTokens.remove(query);                                                                        // 1136
    };                                                                                                                 // 1137
  })();                                                                                                                // 1121
}                                                                                                                      // 1138
                                                                                                                       //
// TODO(someday): clean this up.  Logic for building static asset urls on client and server                            //
// appears all over the codebase.                                                                                      //
var httpProtocol = void 0;                                                                                             // 1142
if (Meteor.isServer) {                                                                                                 // 1143
  var _Url = Npm.require("url");                                                                                       // 1144
  httpProtocol = _Url.parse(process.env.ROOT_URL).protocol;                                                            // 1145
} else {                                                                                                               // 1146
  httpProtocol = window.location.protocol;                                                                             // 1147
}                                                                                                                      // 1148
                                                                                                                       //
// =======================================================================================                             //
// Below this point are newly-written or refactored functions.                                                         //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1153
  getUser: function getUser(userId) {                                                                                  // 1154
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1155
    if (userId) {                                                                                                      // 1156
      return Meteor.users.findOne(userId);                                                                             // 1157
    }                                                                                                                  // 1158
  },                                                                                                                   // 1159
                                                                                                                       //
  getIdentity: function getIdentity(identityId) {                                                                      // 1161
    check(identityId, String);                                                                                         // 1162
    var identity = Meteor.users.findOne({ _id: identityId });                                                          // 1163
    if (identity) {                                                                                                    // 1164
      SandstormDb.fillInProfileDefaults(identity);                                                                     // 1165
      SandstormDb.fillInIntrinsicName(identity);                                                                       // 1166
      SandstormDb.fillInPictureUrl(identity);                                                                          // 1167
      return identity;                                                                                                 // 1168
    }                                                                                                                  // 1169
  },                                                                                                                   // 1170
                                                                                                                       //
  userHasIdentity: function userHasIdentity(userId, identityId) {                                                      // 1172
    check(userId, String);                                                                                             // 1173
    check(identityId, String);                                                                                         // 1174
                                                                                                                       //
    if (userId === identityId) return true;                                                                            // 1176
                                                                                                                       //
    var user = Meteor.users.findOne(userId);                                                                           // 1178
    return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                             // 1179
  },                                                                                                                   // 1180
                                                                                                                       //
  userGrains: function userGrains(userId, trashed) {                                                                   // 1182
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1183
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1184
                                                                                                                       //
    return this.collections.grains.find({ userId: userId, trashed: { $exists: !!trashed } });                          // 1186
  },                                                                                                                   // 1187
                                                                                                                       //
  currentUserGrains: function currentUserGrains(trashed) {                                                             // 1189
    return this.userGrains(Meteor.userId(), trashed);                                                                  // 1190
  },                                                                                                                   // 1191
                                                                                                                       //
  getGrain: function getGrain(grainId) {                                                                               // 1193
    check(grainId, String);                                                                                            // 1194
    return this.collections.grains.findOne(grainId);                                                                   // 1195
  },                                                                                                                   // 1196
                                                                                                                       //
  userApiTokens: function userApiTokens(userId, trashed) {                                                             // 1198
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1199
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1200
    var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                            // 1201
    return this.collections.apiTokens.find({                                                                           // 1202
      "owner.user.identityId": { $in: identityIds },                                                                   // 1203
      trashed: { $exists: !!trashed }                                                                                  // 1204
    });                                                                                                                // 1202
  },                                                                                                                   // 1206
                                                                                                                       //
  currentUserApiTokens: function currentUserApiTokens(trashed) {                                                       // 1208
    return this.userApiTokens(Meteor.userId(), trashed);                                                               // 1209
  },                                                                                                                   // 1210
                                                                                                                       //
  userActions: function userActions(user) {                                                                            // 1212
    return this.collections.userActions.find({ userId: user });                                                        // 1213
  },                                                                                                                   // 1214
                                                                                                                       //
  currentUserActions: function currentUserActions() {                                                                  // 1216
    return this.userActions(Meteor.userId());                                                                          // 1217
  },                                                                                                                   // 1218
                                                                                                                       //
  iconSrcForPackage: function iconSrcForPackage(pkg, usage) {                                                          // 1220
    return Identicon.iconSrcForPackage(pkg, usage, httpProtocol + "//" + this.makeWildcardHost("static"));             // 1221
  },                                                                                                                   // 1222
                                                                                                                       //
  getDenormalizedGrainInfo: function getDenormalizedGrainInfo(grainId) {                                               // 1224
    var grain = this.getGrain(grainId);                                                                                // 1225
    var pkg = this.collections.packages.findOne(grain.packageId);                                                      // 1226
                                                                                                                       //
    if (!pkg) {                                                                                                        // 1228
      pkg = this.collections.devPackages.findOne(grain.packageId);                                                     // 1229
    }                                                                                                                  // 1230
                                                                                                                       //
    var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                                // 1232
    var grainInfo = { appTitle: appTitle };                                                                            // 1233
                                                                                                                       //
    if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                                 // 1235
      var icons = pkg.manifest.metadata.icons;                                                                         // 1236
      grainInfo.icon = icons.grain || icons.appGrid;                                                                   // 1237
    }                                                                                                                  // 1238
                                                                                                                       //
    // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                      //
    if (!grainInfo.icon && pkg) {                                                                                      // 1241
      grainInfo.appId = pkg.appId;                                                                                     // 1242
    }                                                                                                                  // 1243
                                                                                                                       //
    return grainInfo;                                                                                                  // 1245
  },                                                                                                                   // 1246
                                                                                                                       //
  getPlan: function getPlan(id) {                                                                                      // 1248
    check(id, String);                                                                                                 // 1249
    var plan = Plans.findOne(id);                                                                                      // 1250
    if (!plan) {                                                                                                       // 1251
      throw new Error("no such plan: " + id);                                                                          // 1252
    }                                                                                                                  // 1253
                                                                                                                       //
    return plan;                                                                                                       // 1255
  },                                                                                                                   // 1256
                                                                                                                       //
  listPlans: function listPlans() {                                                                                    // 1258
    return Plans.find({}, { sort: { price: 1 } });                                                                     // 1259
  },                                                                                                                   // 1260
                                                                                                                       //
  getMyPlan: function getMyPlan() {                                                                                    // 1262
    var user = Meteor.user();                                                                                          // 1263
    return user && Plans.findOne(user.plan || "free");                                                                 // 1264
  },                                                                                                                   // 1265
                                                                                                                       //
  getMyReferralBonus: function getMyReferralBonus(user) {                                                              // 1267
    // This function is called from the server and from the client, similar to getMyPlan().                            //
    //                                                                                                                 //
    // The parameter may be omitted in which case the current user is assumed.                                         //
                                                                                                                       //
    return calculateReferralBonus(user || Meteor.user());                                                              // 1272
  },                                                                                                                   // 1273
                                                                                                                       //
  getMyUsage: function getMyUsage(user) {                                                                              // 1275
    user = user || Meteor.user();                                                                                      // 1276
    if (user && (Meteor.isServer || user.pseudoUsage)) {                                                               // 1277
      if (Meteor.isClient) {                                                                                           // 1278
        // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currently                       //
        // not reactive.                                                                                               //
        return user.pseudoUsage;                                                                                       // 1281
      } else {                                                                                                         // 1282
        return {                                                                                                       // 1283
          grains: Grains.find({ userId: user._id }).count(),                                                           // 1284
          storage: user.storageUsage || 0,                                                                             // 1285
          compute: 0 };                                                                                                // 1286
      }                                                                                                                // 1288
    } else // not tracked yet                                                                                          // 1289
      {                                                                                                                // 1289
        return { grains: 0, storage: 0, compute: 0 };                                                                  // 1290
      }                                                                                                                // 1291
  },                                                                                                                   // 1292
                                                                                                                       //
  isUninvitedFreeUser: function isUninvitedFreeUser() {                                                                // 1294
    if (!Meteor.settings["public"].allowUninvited) return false;                                                       // 1295
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1297
    return user && !user.expires && (!user.plan || user.plan === "free");                                              // 1298
  },                                                                                                                   // 1299
                                                                                                                       //
  getSetting: function getSetting(name) {                                                                              // 1301
    var setting = Settings.findOne(name);                                                                              // 1302
    return setting && setting.value;                                                                                   // 1303
  },                                                                                                                   // 1304
                                                                                                                       //
  getSettingWithFallback: function getSettingWithFallback(name, fallbackValue) {                                       // 1306
    var value = this.getSetting(name);                                                                                 // 1307
    if (value === undefined) {                                                                                         // 1308
      return fallbackValue;                                                                                            // 1309
    }                                                                                                                  // 1310
                                                                                                                       //
    return value;                                                                                                      // 1312
  },                                                                                                                   // 1313
                                                                                                                       //
  addUserActions: function addUserActions(userId, packageId, simulation) {                                             // 1315
    check(userId, String);                                                                                             // 1316
    check(packageId, String);                                                                                          // 1317
                                                                                                                       //
    var pack = Packages.findOne({ _id: packageId });                                                                   // 1319
    if (pack) {                                                                                                        // 1320
      // Remove old versions.                                                                                          //
      var numRemoved = UserActions.remove({ userId: userId, appId: pack.appId });                                      // 1322
                                                                                                                       //
      // Install new.                                                                                                  //
      var actions = pack.manifest.actions;                                                                             // 1325
      for (var i in actions) {                                                                                         // 1326
        var action = actions[i];                                                                                       // 1327
        if ("none" in action.input) {                                                                                  // 1328
          var userAction = {                                                                                           // 1329
            userId: userId,                                                                                            // 1330
            packageId: pack._id,                                                                                       // 1331
            appId: pack.appId,                                                                                         // 1332
            appTitle: pack.manifest.appTitle,                                                                          // 1333
            appMarketingVersion: pack.manifest.appMarketingVersion,                                                    // 1334
            appVersion: pack.manifest.appVersion,                                                                      // 1335
            title: action.title,                                                                                       // 1336
            nounPhrase: action.nounPhrase,                                                                             // 1337
            command: action.command                                                                                    // 1338
          };                                                                                                           // 1329
          UserActions.insert(userAction);                                                                              // 1340
        } else {                                                                                                       // 1341
          // TODO(someday):  Implement actions with capability inputs.                                                 //
        }                                                                                                              // 1343
      }                                                                                                                // 1344
                                                                                                                       //
      if (numRemoved > 0 && !simulation) {                                                                             // 1346
        this.deleteUnusedPackages(pack.appId);                                                                         // 1347
      }                                                                                                                // 1348
    }                                                                                                                  // 1349
  },                                                                                                                   // 1350
                                                                                                                       //
  sendAdminNotification: function sendAdminNotification(message, link) {                                               // 1352
    Meteor.users.find({ isAdmin: true }, { fields: { _id: 1 } }).forEach(function (user) {                             // 1353
      Notifications.insert({                                                                                           // 1354
        admin: {                                                                                                       // 1355
          action: link,                                                                                                // 1356
          type: "reportStats"                                                                                          // 1357
        },                                                                                                             // 1355
        userId: user._id,                                                                                              // 1359
        text: { defaultText: message },                                                                                // 1360
        timestamp: new Date(),                                                                                         // 1361
        isUnread: true                                                                                                 // 1362
      });                                                                                                              // 1354
    });                                                                                                                // 1364
  },                                                                                                                   // 1365
                                                                                                                       //
  getKeybaseProfile: function getKeybaseProfile(keyFingerprint) {                                                      // 1367
    return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                             // 1368
  },                                                                                                                   // 1369
                                                                                                                       //
  getServerTitle: function getServerTitle() {                                                                          // 1371
    var setting = Settings.findOne({ _id: "serverTitle" });                                                            // 1372
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1373
  },                                                                                                                   // 1374
                                                                                                                       //
  getSmtpConfig: function getSmtpConfig() {                                                                            // 1376
    var setting = Settings.findOne({ _id: "smtpConfig" });                                                             // 1377
    return setting ? setting.value : undefined; // undefined if subscription is not ready.                             // 1378
  },                                                                                                                   // 1379
                                                                                                                       //
                                                                                                                       //
  getReturnAddress: function getReturnAddress() {                                                                      // 1381
    var config = this.getSmtpConfig();                                                                                 // 1382
    return config && config.returnAddress || ""; // empty if subscription is not ready.                                // 1383
  },                                                                                                                   // 1384
                                                                                                                       //
  getReturnAddressWithDisplayName: function getReturnAddressWithDisplayName(identityId) {                              // 1386
    check(identityId, String);                                                                                         // 1387
    var identity = this.getIdentity(identityId);                                                                       // 1388
    var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")";                                  // 1389
                                                                                                                       //
    // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,                            //
    // we could escape such characters with a backslash, but that does not seem to help here.                          //
    var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                           // 1393
                                                                                                                       //
    return "\"" + sanitized + "\" <" + this.getReturnAddress() + ">";                                                  // 1395
  },                                                                                                                   // 1396
                                                                                                                       //
  getPrimaryEmail: function getPrimaryEmail(accountId, identityId) {                                                   // 1398
    check(accountId, String);                                                                                          // 1399
    check(identityId, String);                                                                                         // 1400
                                                                                                                       //
    var identity = this.getIdentity(identityId);                                                                       // 1402
    var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                        // 1403
    var senderPrimaryEmail = _.findWhere(senderEmails, { primary: true });                                             // 1404
    var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                             // 1405
    if (_.findWhere(senderEmails, { email: accountPrimaryEmailAddress })) {                                            // 1406
      return accountPrimaryEmailAddress;                                                                               // 1407
    } else if (senderPrimaryEmail) {                                                                                   // 1408
      return senderPrimaryEmail.email;                                                                                 // 1409
    } else {                                                                                                           // 1410
      return null;                                                                                                     // 1411
    }                                                                                                                  // 1412
  },                                                                                                                   // 1413
                                                                                                                       //
  incrementDailySentMailCount: function incrementDailySentMailCount(accountId) {                                       // 1415
    check(accountId, String);                                                                                          // 1416
                                                                                                                       //
    var DAILY_LIMIT = 50;                                                                                              // 1418
    var result = Meteor.users.findAndModify({                                                                          // 1419
      query: { _id: accountId },                                                                                       // 1420
      update: {                                                                                                        // 1421
        $inc: {                                                                                                        // 1422
          dailySentMailCount: 1                                                                                        // 1423
        }                                                                                                              // 1422
      },                                                                                                               // 1421
      fields: { dailySentMailCount: 1 }                                                                                // 1426
    });                                                                                                                // 1419
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 1429
      throw new Error("Couldn't update daily sent mail count.");                                                       // 1430
    }                                                                                                                  // 1431
                                                                                                                       //
    var user = result.value;                                                                                           // 1433
    if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                      // 1434
      throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
    }                                                                                                                  // 1439
  },                                                                                                                   // 1440
                                                                                                                       //
  isFeatureKeyValid: function isFeatureKeyValid() {                                                                    // 1442
    var featureKey = this.currentFeatureKey();                                                                         // 1443
    return !!featureKey;                                                                                               // 1444
  },                                                                                                                   // 1445
                                                                                                                       //
  isFeatureKeyValidAndNotExpired: function isFeatureKeyValidAndNotExpired() {                                          // 1447
    var featureKey = this.currentFeatureKey();                                                                         // 1448
    return featureKey && parseInt(featureKey.expires) > Date.now() / 1000;                                             // 1449
  },                                                                                                                   // 1450
                                                                                                                       //
  getLdapUrl: function getLdapUrl() {                                                                                  // 1452
    var setting = Settings.findOne({ _id: "ldapUrl" });                                                                // 1453
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1454
  },                                                                                                                   // 1455
                                                                                                                       //
  getLdapBase: function getLdapBase() {                                                                                // 1457
    var setting = Settings.findOne({ _id: "ldapBase" });                                                               // 1458
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1459
  },                                                                                                                   // 1460
                                                                                                                       //
  getLdapDnPattern: function getLdapDnPattern() {                                                                      // 1462
    var setting = Settings.findOne({ _id: "ldapDnPattern" });                                                          // 1463
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1464
  },                                                                                                                   // 1465
                                                                                                                       //
  getLdapSearchUsername: function getLdapSearchUsername() {                                                            // 1467
    var setting = Settings.findOne({ _id: "ldapSearchUsername" });                                                     // 1468
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1469
  },                                                                                                                   // 1470
                                                                                                                       //
  getLdapNameField: function getLdapNameField() {                                                                      // 1472
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 1473
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1474
  },                                                                                                                   // 1475
                                                                                                                       //
  getLdapEmailField: function getLdapEmailField() {                                                                    // 1477
    var setting = Settings.findOne({ _id: "ldapEmailField" });                                                         // 1478
    return setting ? setting.value : "mail";                                                                           // 1479
    // default to "mail". This setting was added later, and so could potentially be unset.                             //
  },                                                                                                                   // 1481
                                                                                                                       //
  getLdapExplicitDnSelected: function getLdapExplicitDnSelected() {                                                    // 1483
    var setting = Settings.findOne({ _id: "ldapExplicitDnSelected" });                                                 // 1484
    return setting && setting.value;                                                                                   // 1485
  },                                                                                                                   // 1486
                                                                                                                       //
  getLdapFilter: function getLdapFilter() {                                                                            // 1488
    var setting = Settings.findOne({ _id: "ldapFilter" });                                                             // 1489
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1490
  },                                                                                                                   // 1491
                                                                                                                       //
  getLdapSearchBindDn: function getLdapSearchBindDn() {                                                                // 1493
    var setting = Settings.findOne({ _id: "ldapSearchBindDn" });                                                       // 1494
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1495
  },                                                                                                                   // 1496
                                                                                                                       //
  getLdapSearchBindPassword: function getLdapSearchBindPassword() {                                                    // 1498
    var setting = Settings.findOne({ _id: "ldapSearchBindPassword" });                                                 // 1499
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1500
  },                                                                                                                   // 1501
                                                                                                                       //
  getOrganizationMembership: function getOrganizationMembership() {                                                    // 1503
    var setting = Settings.findOne({ _id: "organizationMembership" });                                                 // 1504
    return setting && setting.value;                                                                                   // 1505
  },                                                                                                                   // 1506
                                                                                                                       //
  getOrganizationEmailEnabled: function getOrganizationEmailEnabled() {                                                // 1508
    var membership = this.getOrganizationMembership();                                                                 // 1509
    return membership && membership.emailToken && membership.emailToken.enabled;                                       // 1510
  },                                                                                                                   // 1511
                                                                                                                       //
  getOrganizationEmailDomain: function getOrganizationEmailDomain() {                                                  // 1513
    var membership = this.getOrganizationMembership();                                                                 // 1514
    return membership && membership.emailToken && membership.emailToken.domain;                                        // 1515
  },                                                                                                                   // 1516
                                                                                                                       //
  getOrganizationGoogleEnabled: function getOrganizationGoogleEnabled() {                                              // 1518
    var membership = this.getOrganizationMembership();                                                                 // 1519
    return membership && membership.google && membership.google.enabled;                                               // 1520
  },                                                                                                                   // 1521
                                                                                                                       //
  getOrganizationGoogleDomain: function getOrganizationGoogleDomain() {                                                // 1523
    var membership = this.getOrganizationMembership();                                                                 // 1524
    return membership && membership.google && membership.google.domain;                                                // 1525
  },                                                                                                                   // 1526
                                                                                                                       //
  getOrganizationLdapEnabled: function getOrganizationLdapEnabled() {                                                  // 1528
    var membership = this.getOrganizationMembership();                                                                 // 1529
    return membership && membership.ldap && membership.ldap.enabled;                                                   // 1530
  },                                                                                                                   // 1531
                                                                                                                       //
  getOrganizationSamlEnabled: function getOrganizationSamlEnabled() {                                                  // 1533
    var membership = this.getOrganizationMembership();                                                                 // 1534
    return membership && membership.saml && membership.saml.enabled;                                                   // 1535
  },                                                                                                                   // 1536
                                                                                                                       //
  getOrganizationDisallowGuests: function getOrganizationDisallowGuests() {                                            // 1538
    return this.getOrganizationDisallowGuestsRaw() && this.isFeatureKeyValid();                                        // 1539
  },                                                                                                                   // 1540
                                                                                                                       //
  getOrganizationDisallowGuestsRaw: function getOrganizationDisallowGuestsRaw() {                                      // 1542
    var setting = Settings.findOne({ _id: "organizationSettings" });                                                   // 1543
    return setting && setting.value && setting.value.disallowGuests;                                                   // 1544
  },                                                                                                                   // 1545
                                                                                                                       //
  getOrganizationShareContacts: function getOrganizationShareContacts() {                                              // 1547
    return this.getOrganizationShareContactsRaw() && this.isFeatureKeyValid();                                         // 1548
  },                                                                                                                   // 1549
                                                                                                                       //
  getOrganizationShareContactsRaw: function getOrganizationShareContactsRaw() {                                        // 1551
    var setting = Settings.findOne({ _id: "organizationSettings" });                                                   // 1552
    if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                     // 1553
      // default to true if undefined                                                                                  //
      return true;                                                                                                     // 1555
    } else {                                                                                                           // 1556
      return setting.value.shareContacts;                                                                              // 1557
    }                                                                                                                  // 1558
  },                                                                                                                   // 1559
                                                                                                                       //
  getSamlEntryPoint: function getSamlEntryPoint() {                                                                    // 1561
    var setting = Settings.findOne({ _id: "samlEntryPoint" });                                                         // 1562
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1563
  },                                                                                                                   // 1564
                                                                                                                       //
  getSamlPublicCert: function getSamlPublicCert() {                                                                    // 1566
    var setting = Settings.findOne({ _id: "samlPublicCert" });                                                         // 1567
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1568
  },                                                                                                                   // 1569
                                                                                                                       //
  getSamlEntityId: function getSamlEntityId() {                                                                        // 1571
    var setting = Settings.findOne({ _id: "samlEntityId" });                                                           // 1572
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1573
  },                                                                                                                   // 1574
                                                                                                                       //
  getActivitySubscriptions: function getActivitySubscriptions(grainId, threadPath) {                                   // 1576
    return ActivitySubscriptions.find({                                                                                // 1577
      grainId: grainId,                                                                                                // 1578
      threadPath: threadPath || { $exists: false }                                                                     // 1579
    }, {                                                                                                               // 1577
      fields: { identityId: 1, mute: 1, _id: 0 }                                                                       // 1581
    }).fetch();                                                                                                        // 1580
  },                                                                                                                   // 1583
                                                                                                                       //
  subscribeToActivity: function subscribeToActivity(identityId, grainId, threadPath) {                                 // 1585
    // Subscribe the given identity to activity events with the given grainId and (optional)                           //
    // threadPath -- unless the identity has previously muted this grainId/threadPath, in which                        //
    // case do nothing.                                                                                                //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1590
    if (threadPath) {                                                                                                  // 1591
      record.threadPath = threadPath;                                                                                  // 1592
    }                                                                                                                  // 1593
                                                                                                                       //
    // The $set here is redundant since an upsert automatically initializes a new record to contain                    //
    // the fields from the query, but if we try to do { $set: {} } Mongo throws an exception, and                      //
    // if we try to just pass {}, Mongo interprets it as "replace the record with an empty record".                    //
    // What a wonderful query language.                                                                                //
    ActivitySubscriptions.upsert(record, { $set: record });                                                            // 1599
  },                                                                                                                   // 1600
                                                                                                                       //
  muteActivity: function muteActivity(identityId, grainId, threadPath) {                                               // 1602
    // Mute notifications for the given identity originating from the given grainId and                                //
    // (optional) threadPath.                                                                                          //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1606
    if (threadPath) {                                                                                                  // 1607
      record.threadPath = threadPath;                                                                                  // 1608
    }                                                                                                                  // 1609
                                                                                                                       //
    ActivitySubscriptions.upsert(record, { $set: { mute: true } });                                                    // 1611
  },                                                                                                                   // 1612
                                                                                                                       //
  updateAppIndex: function updateAppIndex() {                                                                          // 1614
    var _this2 = this;                                                                                                 // 1614
                                                                                                                       //
    var appUpdatesEnabledSetting = this.collections.settings.findOne({ _id: "appUpdatesEnabled" });                    // 1615
    var appUpdatesEnabled = appUpdatesEnabledSetting && appUpdatesEnabledSetting.value;                                // 1616
    if (!appUpdatesEnabled) {                                                                                          // 1617
      // It's much simpler to check appUpdatesEnabled here rather than reactively deactivate the                       //
      // timer that triggers this call.                                                                                //
      return;                                                                                                          // 1620
    }                                                                                                                  // 1621
                                                                                                                       //
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1623
    var appIndex = this.collections.appIndex;                                                                          // 1624
    var data = HTTP.get(appIndexUrl + "/apps/index.json").data;                                                        // 1625
    var preinstalledAppIds = this.getAllPreinstalledAppIds();                                                          // 1626
    // We make sure to get all preinstalled appIds, even ones that are currently                                       //
    // downloading/failed.                                                                                             //
    data.apps.forEach(function (app) {                                                                                 // 1629
      app._id = app.appId;                                                                                             // 1630
                                                                                                                       //
      var oldApp = appIndex.findOne({ _id: app.appId });                                                               // 1632
      app.hasSentNotifications = false;                                                                                // 1633
      appIndex.upsert({ _id: app._id }, app);                                                                          // 1634
      var isAppPreinstalled = _.contains(preinstalledAppIds, app.appId);                                               // 1635
      if ((!oldApp || app.versionNumber > oldApp.versionNumber) && (_this2.collections.userActions.findOne({ appId: app.appId }) || isAppPreinstalled)) {
        var pack = _this2.collections.packages.findOne({ _id: app.packageId });                                        // 1639
        var url = appIndexUrl + "/packages/" + app.packageId;                                                          // 1640
        if (pack) {                                                                                                    // 1641
          if (pack.status === "ready") {                                                                               // 1642
            if (pack.appId && pack.appId !== app.appId) {                                                              // 1643
              console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));        // 1644
            } else {                                                                                                   // 1646
              _this2.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);   // 1647
            }                                                                                                          // 1649
          } else {                                                                                                     // 1650
            var result = Packages.findAndModify({                                                                      // 1651
              query: { _id: app.packageId },                                                                           // 1652
              update: { $set: { isAutoUpdated: true } }                                                                // 1653
            });                                                                                                        // 1651
                                                                                                                       //
            if (!result.ok) {                                                                                          // 1656
              return;                                                                                                  // 1657
            }                                                                                                          // 1658
                                                                                                                       //
            var newPack = result.value;                                                                                // 1660
            if (newPack.status === "ready") {                                                                          // 1661
              // The package was marked as ready before we applied isAutoUpdated=true. We should send                  //
              // notifications ourselves to be sure there's no timing issue (sending more than one is                  //
              // fine, since it will de-dupe).                                                                         //
              if (pack.appId && pack.appId !== app.appId) {                                                            // 1665
                console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));      // 1666
              } else {                                                                                                 // 1668
                _this2.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
              }                                                                                                        // 1671
            } else if (newPack.status === "failed") {                                                                  // 1672
              // If the package has failed, retry it                                                                   //
              _this2.startInstall(app.packageId, url, true, true);                                                     // 1674
            }                                                                                                          // 1675
          }                                                                                                            // 1676
        } else {                                                                                                       // 1677
          _this2.startInstall(app.packageId, url, false, true);                                                        // 1678
        }                                                                                                              // 1679
      }                                                                                                                // 1680
    });                                                                                                                // 1681
  },                                                                                                                   // 1682
                                                                                                                       //
  isPackagePreinstalled: function isPackagePreinstalled(packageId) {                                                   // 1684
    return Settings.find({ _id: "preinstalledApps", "value.packageId": packageId }).count() === 1;                     // 1685
  },                                                                                                                   // 1686
                                                                                                                       //
  getAppIdForPreinstalledPackage: function getAppIdForPreinstalledPackage(packageId) {                                 // 1688
    var setting = Settings.findOne({ _id: "preinstalledApps", "value.packageId": packageId }, { fields: { "value.$": 1 } });
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].appId;                                     // 1693
  },                                                                                                                   // 1694
                                                                                                                       //
  getPackageIdForPreinstalledApp: function getPackageIdForPreinstalledApp(appId) {                                     // 1696
    var setting = Settings.findOne({ _id: "preinstalledApps", "value.appId": appId }, { fields: { "value.$": 1 } });   // 1697
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].packageId;                                 // 1701
  },                                                                                                                   // 1702
                                                                                                                       //
  getReadyPreinstalledAppIds: function getReadyPreinstalledAppIds() {                                                  // 1704
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1705
    var ret = setting && setting.value || [];                                                                          // 1706
    return _.chain(ret).filter(function (app) {                                                                        // 1707
      return app.status === "ready";                                                                                   // 1708
    }).map(function (app) {                                                                                            // 1708
      return app.appId;                                                                                                // 1709
    }).value();                                                                                                        // 1709
  },                                                                                                                   // 1711
                                                                                                                       //
  getAllPreinstalledAppIds: function getAllPreinstalledAppIds() {                                                      // 1713
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1714
    var ret = setting && setting.value || [];                                                                          // 1715
    return _.map(ret, function (app) {                                                                                 // 1716
      return app.appId;                                                                                                // 1716
    });                                                                                                                // 1716
  },                                                                                                                   // 1717
                                                                                                                       //
  preinstallAppsForUser: function preinstallAppsForUser(userId) {                                                      // 1719
    var _this3 = this;                                                                                                 // 1719
                                                                                                                       //
    var appIds = this.getReadyPreinstalledAppIds();                                                                    // 1720
    appIds.forEach(function (appId) {                                                                                  // 1721
      try {                                                                                                            // 1722
        _this3.addUserActions(userId, _this3.getPackageIdForPreinstalledApp(appId));                                   // 1723
      } catch (e) {                                                                                                    // 1724
        console.error("failed to install app for user:", e);                                                           // 1725
      }                                                                                                                // 1726
    });                                                                                                                // 1727
  },                                                                                                                   // 1728
                                                                                                                       //
  setPreinstallAppAsDownloading: function setPreinstallAppAsDownloading(appId, packageId) {                            // 1730
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId, "value.packageId": packageId }, { $set: { "value.$.status": "downloading" } });
  },                                                                                                                   // 1734
                                                                                                                       //
  setPreinstallAppAsReady: function setPreinstallAppAsReady(appId, packageId) {                                        // 1736
    // This function both sets the appId as ready and updates the packageId for the given appId                        //
    // Setting the packageId is especially useful in installer.js, as it always ensures the                            //
    // latest installed package will be set as ready.                                                                  //
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId }, { $set: { "value.$.status": "ready", "value.$.packageId": packageId } });
  },                                                                                                                   // 1743
                                                                                                                       //
  ensureAppPreinstall: function ensureAppPreinstall(appId, packageId) {                                                // 1745
    check(appId, String);                                                                                              // 1746
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1747
    var pack = this.collections.packages.findOne({ _id: packageId });                                                  // 1748
    var url = appIndexUrl + "/packages/" + packageId;                                                                  // 1749
    if (pack && pack.status === "ready") {                                                                             // 1750
      this.setPreinstallAppAsReady(appId, packageId);                                                                  // 1751
    } else if (pack && pack.status === "failed") {                                                                     // 1752
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1753
      this.startInstall(packageId, url, true, false);                                                                  // 1754
    } else {                                                                                                           // 1755
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1756
      this.startInstall(packageId, url, false, false);                                                                 // 1757
    }                                                                                                                  // 1758
  },                                                                                                                   // 1759
                                                                                                                       //
  setPreinstalledApps: function setPreinstalledApps(appAndPackageIds) {                                                // 1761
    var _this4 = this;                                                                                                 // 1761
                                                                                                                       //
    // appAndPackageIds: A List[Object] where each element has fields:                                                 //
    //     appId: The Packages.appId of the app to install                                                             //
    //     packageId: The Packages._id of the app to install                                                           //
    check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                   // 1765
                                                                                                                       //
    // Start by clearing out the setting. We'll push appIds one by one to it                                           //
    this.collections.settings.upsert({ _id: "preinstalledApps" }, { $set: {                                            // 1768
        value: appAndPackageIds.map(function (data) {                                                                  // 1769
          return {                                                                                                     // 1770
            appId: data.appId,                                                                                         // 1771
            status: "notReady",                                                                                        // 1772
            packageId: data.packageId                                                                                  // 1773
          };                                                                                                           // 1770
        })                                                                                                             // 1775
      } });                                                                                                            // 1768
    appAndPackageIds.forEach(function (data) {                                                                         // 1777
      _this4.ensureAppPreinstall(data.appId, data.packageId);                                                          // 1778
    });                                                                                                                // 1779
  },                                                                                                                   // 1780
                                                                                                                       //
  getProductivitySuiteAppIds: function getProductivitySuiteAppIds() {                                                  // 1782
    return ["8aspz4sfjnp8u89000mh2v1xrdyx97ytn8hq71mdzv4p4d8n0n3h", // Davros                                          // 1783
    "h37dm17aa89yrd8zuqpdn36p6zntumtv08fjpu8a8zrte7q1cn60", // Etherpad                                                // 1785
    "vfnwptfn02ty21w715snyyczw0nqxkv3jvawcah10c6z7hj1hnu0", // Rocket.Chat                                             // 1786
    "m86q05rdvj14yvn78ghaxynqz7u2svw6rnttptxx49g1785cdv1h"];                                                           // 1787
  },                                                                                                                   // 1789
                                                                                                                       //
  // Wekan                                                                                                             //
  getSystemSuiteAppIds: function getSystemSuiteAppIds() {                                                              // 1791
    return ["s3u2xgmqwznz2n3apf30sm3gw1d85y029enw5pymx734cnk5n78h"];                                                   // 1792
  },                                                                                                                   // 1795
                                                                                                                       //
  // Collections                                                                                                       //
  isPreinstalledAppsReady: function isPreinstalledAppsReady() {                                                        // 1797
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1798
    if (!setting || !setting.value) {                                                                                  // 1799
      return true;                                                                                                     // 1800
    }                                                                                                                  // 1801
                                                                                                                       //
    var packageIds = _.pluck(setting.value, "packageId");                                                              // 1803
    var readyApps = this.collections.packages.find({                                                                   // 1804
      _id: {                                                                                                           // 1805
        $in: packageIds                                                                                                // 1806
      },                                                                                                               // 1805
      status: "ready"                                                                                                  // 1808
    });                                                                                                                // 1804
    return readyApps.count() === packageIds.length;                                                                    // 1810
  },                                                                                                                   // 1811
                                                                                                                       //
  getBillingPromptUrl: function getBillingPromptUrl() {                                                                // 1813
    var setting = this.collections.settings.findOne({ _id: "billingPromptUrl" });                                      // 1814
    return setting && setting.value;                                                                                   // 1815
  },                                                                                                                   // 1816
                                                                                                                       //
  isReferralEnabled: function isReferralEnabled() {                                                                    // 1818
    // This function is a bit weird, in that we've transitioned from                                                   //
    // Meteor.settings.public.quotaEnabled to DB settings. For now,                                                    //
    // Meteor.settings.public.quotaEnabled implies bothisReferralEnabled and isQuotaEnabled are true.                  //
    return Meteor.settings["public"].quotaEnabled;                                                                     // 1822
  },                                                                                                                   // 1823
                                                                                                                       //
  isQuotaEnabled: function isQuotaEnabled() {                                                                          // 1825
    if (Meteor.settings["public"].quotaEnabled) return true;                                                           // 1826
                                                                                                                       //
    var setting = this.collections.settings.findOne({ _id: "quotaEnabled" });                                          // 1828
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1829
  },                                                                                                                   // 1830
                                                                                                                       //
  isQuotaLdapEnabled: function isQuotaLdapEnabled() {                                                                  // 1832
    var setting = this.collections.settings.findOne({ _id: "quotaLdapEnabled" });                                      // 1833
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1834
  },                                                                                                                   // 1835
                                                                                                                       //
  updateUserQuota: function updateUserQuota(user) {                                                                    // 1837
    if (this.quotaManager) {                                                                                           // 1838
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1839
    }                                                                                                                  // 1840
  },                                                                                                                   // 1841
                                                                                                                       //
  getUserQuota: function getUserQuota(user) {                                                                          // 1843
    if (this.isQuotaLdapEnabled()) {                                                                                   // 1844
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1845
    } else {                                                                                                           // 1846
      var plan = Plans.findOne(user.plan || "free");                                                                   // 1847
      var referralBonus = calculateReferralBonus(user);                                                                // 1848
      var bonus = user.planBonus || {};                                                                                // 1849
      var userQuota = {                                                                                                // 1850
        storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                          // 1851
        grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                              // 1852
        compute: plan.compute + (bonus.compute || 0)                                                                   // 1853
      };                                                                                                               // 1850
      return userQuota;                                                                                                // 1855
    }                                                                                                                  // 1856
  },                                                                                                                   // 1857
                                                                                                                       //
  isUserOverQuota: function isUserOverQuota(user) {                                                                    // 1859
    // Return false if user has quota space remaining, true if it is full. When this returns true,                     //
    // we will not allow the user to create new grains, though they may be able to open existing ones                  //
    // which may still increase their storage usage.                                                                   //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1866
                                                                                                                       //
    var plan = this.getUserQuota(user);                                                                                // 1868
    if (plan.grains < Infinity) {                                                                                      // 1869
      var count = this.collections.grains.find({ userId: user._id }, { fields: {}, limit: plan.grains }).count();      // 1870
      if (count >= plan.grains) return "outOfGrains";                                                                  // 1872
    }                                                                                                                  // 1873
                                                                                                                       //
    return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                           // 1875
  },                                                                                                                   // 1876
                                                                                                                       //
  isUserExcessivelyOverQuota: function isUserExcessivelyOverQuota(user) {                                              // 1878
    // Return true if user is so far over quota that we should prevent their existing grains from                      //
    // running at all.                                                                                                 //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1884
                                                                                                                       //
    var quota = this.getUserQuota(user);                                                                               // 1886
                                                                                                                       //
    // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.                           //
    if (quota.grains < Infinity) {                                                                                     // 1889
      var count = this.collections.grains.find({ userId: user._id }, { fields: {}, limit: quota.grains * 2 }).count();
      if (count >= quota.grains * 2) return "outOfGrains";                                                             // 1892
    }                                                                                                                  // 1893
                                                                                                                       //
    return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                   // 1895
  },                                                                                                                   // 1896
                                                                                                                       //
  suspendIdentity: function suspendIdentity(userId, suspension) {                                                      // 1898
    check(userId, String);                                                                                             // 1899
    check(suspension, {                                                                                                // 1900
      timestamp: Date,                                                                                                 // 1901
      admin: Match.Optional(String),                                                                                   // 1902
      voluntary: Match.Optional(Boolean)                                                                               // 1903
    });                                                                                                                // 1900
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                               // 1906
    this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $set: { suspended: true } }, { multi: true });
  },                                                                                                                   // 1909
                                                                                                                       //
  unsuspendIdentity: function unsuspendIdentity(userId) {                                                              // 1911
    check(userId, String);                                                                                             // 1912
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                      // 1914
    this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $unset: { suspended: true } }, { multi: true });
  },                                                                                                                   // 1917
                                                                                                                       //
  suspendAccount: function suspendAccount(userId, byAdminUserId, willDelete) {                                         // 1919
    var _this5 = this;                                                                                                 // 1919
                                                                                                                       //
    check(userId, String);                                                                                             // 1920
    check(byAdminUserId, Match.OneOf(String, null, undefined));                                                        // 1921
    check(willDelete, Boolean);                                                                                        // 1922
                                                                                                                       //
    var user = globalDb.collections.users.findOne({ _id: userId });                                                    // 1924
    var suspension = {                                                                                                 // 1925
      timestamp: new Date(),                                                                                           // 1926
      willDelete: willDelete || false                                                                                  // 1927
    };                                                                                                                 // 1925
    if (byAdminUserId) {                                                                                               // 1929
      suspension.admin = byAdminUserId;                                                                                // 1930
    } else {                                                                                                           // 1931
      suspension.voluntary = true;                                                                                     // 1932
    }                                                                                                                  // 1933
                                                                                                                       //
    this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                               // 1935
    this.collections.grains.update({ userId: userId }, { $set: { suspended: true } }, { multi: true });                // 1936
                                                                                                                       //
    delete suspension.willDelete;                                                                                      // 1938
    // Only mark the parent account for deletion. This makes the query simpler later.                                  //
                                                                                                                       //
    user.loginIdentities.forEach(function (identity) {                                                                 // 1941
      _this5.suspendIdentity(identity.id, suspension);                                                                 // 1942
    });                                                                                                                // 1943
    user.nonloginIdentities.forEach(function (identity) {                                                              // 1944
      if (_this5.collections.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // Only suspend non-login identities that are unique to this account.                                          //
        _this5.suspendIdentity(identity.id, suspension);                                                               // 1950
      }                                                                                                                // 1951
    });                                                                                                                // 1952
                                                                                                                       //
    // Force logout this user                                                                                          //
    this.collections.users.update({ _id: userId }, { $unset: { "services.resume.loginTokens": 1 } });                  // 1955
    if (user && user.loginIdentities) {                                                                                // 1957
      user.loginIdentities.forEach(function (identity) {                                                               // 1958
        Meteor.users.update({ _id: identity.id }, { $unset: { "services.resume.loginTokens": 1 } });                   // 1959
      });                                                                                                              // 1960
    }                                                                                                                  // 1961
  },                                                                                                                   // 1962
                                                                                                                       //
  unsuspendAccount: function unsuspendAccount(userId) {                                                                // 1964
    var _this6 = this;                                                                                                 // 1964
                                                                                                                       //
    check(userId, String);                                                                                             // 1965
                                                                                                                       //
    var user = globalDb.collections.users.findOne({ _id: userId });                                                    // 1967
    this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                      // 1968
    this.collections.grains.update({ userId: userId }, { $unset: { suspended: 1 } }, { multi: true });                 // 1969
                                                                                                                       //
    user.loginIdentities.forEach(function (identity) {                                                                 // 1971
      _this6.unsuspendIdentity(identity.id);                                                                           // 1972
    });                                                                                                                // 1973
                                                                                                                       //
    user.nonloginIdentities.forEach(function (identity) {                                                              // 1975
      _this6.unsuspendIdentity(identity.id);                                                                           // 1976
    });                                                                                                                // 1977
  },                                                                                                                   // 1978
                                                                                                                       //
  deletePendingAccounts: function deletePendingAccounts(deletionCoolingOffTime, backend) {                             // 1980
    var _this7 = this;                                                                                                 // 1980
                                                                                                                       //
    check(deletionCoolingOffTime, Number);                                                                             // 1981
                                                                                                                       //
    var queryDate = new Date(Date.now() - deletionCoolingOffTime);                                                     // 1983
    this.collections.users.find({                                                                                      // 1984
      "suspended.willDelete": true,                                                                                    // 1985
      "suspended.timestamp": { $lt: queryDate }                                                                        // 1986
    }).forEach(function (user) {                                                                                       // 1984
      _this7.deleteAccount(user._id, backend);                                                                         // 1988
    });                                                                                                                // 1989
  }                                                                                                                    // 1990
});                                                                                                                    // 1153
                                                                                                                       //
SandstormDb.escapeMongoKey = function (key) {                                                                          // 1993
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                     //
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                   //
  // and seems to be a de facto standard, for example:                                                                 //
  //   https://www.npmjs.com/package/mongo-key-escape                                                                  //
  return key.replace(".", "．").replace("$", "＄");                                                                      // 1998
};                                                                                                                     // 1999
                                                                                                                       //
var appNameFromPackage = function appNameFromPackage(packageObj) {                                                     // 2001
  // This function takes a Package object from Mongo and returns an                                                    //
  // app title.                                                                                                        //
  var manifest = packageObj.manifest;                                                                                  // 2004
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                               // 2005
  var action = manifest.actions[0];                                                                                    // 2006
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);     // 2007
  return appName;                                                                                                      // 2009
};                                                                                                                     // 2010
                                                                                                                       //
var appNameFromActionName = function appNameFromActionName(name) {                                                     // 2012
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                               //
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                  //
  //   derive the app title from the action title.                                                                     //
  // TODO(cleanup): Get rid of this once apps have real titles.                                                        //
  if (!name) {                                                                                                         // 2017
    return "(unnamed)";                                                                                                // 2018
  }                                                                                                                    // 2019
                                                                                                                       //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                             // 2021
    name = name.slice(4);                                                                                              // 2022
  }                                                                                                                    // 2023
                                                                                                                       //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                       // 2025
    name = "Hacker CMS";                                                                                               // 2026
  } else {                                                                                                             // 2027
    var space = name.indexOf(" ");                                                                                     // 2028
    if (space > 0) {                                                                                                   // 2029
      name = name.slice(0, space);                                                                                     // 2030
    }                                                                                                                  // 2031
  }                                                                                                                    // 2032
                                                                                                                       //
  return name;                                                                                                         // 2034
};                                                                                                                     // 2035
                                                                                                                       //
var appShortDescriptionFromPackage = function appShortDescriptionFromPackage(pkg) {                                    // 2037
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                     // 2041
                                                                                                                       //
var nounPhraseForActionAndAppTitle = function nounPhraseForActionAndAppTitle(action, appTitle) {                       // 2043
  // A hack to deal with legacy apps not including fields in their manifests.                                          //
  // I look forward to the day I can remove most of this code.                                                         //
  // Attempt to figure out the appropriate noun that this action will create.                                          //
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                            //
  if (action.nounPhrase) return action.nounPhrase.defaultText;                                                         // 2048
  // Otherwise, try to guess one from the structure of the action title field                                          //
  if (action.title && action.title.defaultText) {                                                                      // 2050
    var text = action.title.defaultText;                                                                               // 2051
    // Strip a leading "New "                                                                                          //
    if (text.lastIndexOf("New ", 0) === 0) {                                                                           // 2053
      var candidate = text.slice(4);                                                                                   // 2054
      // Strip a leading appname too, if provided                                                                      //
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                  // 2056
        var newCandidate = candidate.slice(appTitle.length);                                                           // 2057
        // Unless that leaves you with no noun, in which case, use "grain"                                             //
        if (newCandidate.length > 0) {                                                                                 // 2059
          return newCandidate.toLowerCase();                                                                           // 2060
        } else {                                                                                                       // 2061
          return "grain";                                                                                              // 2062
        }                                                                                                              // 2063
      }                                                                                                                // 2064
                                                                                                                       //
      return candidate.toLowerCase();                                                                                  // 2066
    }                                                                                                                  // 2067
    // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                        //
    // the package soon.                                                                                               //
    return text;                                                                                                       // 2070
  } else {                                                                                                             // 2071
    return "grain";                                                                                                    // 2072
  }                                                                                                                    // 2073
};                                                                                                                     // 2074
                                                                                                                       //
// Static methods on SandstormDb that don't need an instance.                                                          //
// Largely things that deal with backwards-compatibility.                                                              //
_.extend(SandstormDb, {                                                                                                // 2078
  appNameFromActionName: appNameFromActionName,                                                                        // 2079
  appNameFromPackage: appNameFromPackage,                                                                              // 2080
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                      // 2081
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                       // 2082
});                                                                                                                    // 2078
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2085
  (function () {                                                                                                       // 2085
    var cleanupExpiredAssetUploads = function cleanupExpiredAssetUploads() {                                           // 2085
      AssetUploadTokens.remove({ expires: { $lt: Date.now() } });                                                      // 2310
    };                                                                                                                 // 2311
                                                                                                                       //
    // Cleanup tokens every hour.                                                                                      //
                                                                                                                       //
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 2086
    var ContentType = Npm.require("content-type");                                                                     // 2087
    var Zlib = Npm.require("zlib");                                                                                    // 2088
    var Url = Npm.require("url");                                                                                      // 2089
                                                                                                                       //
    var replicaNumber = Meteor.settings.replicaNumber || 0;                                                            // 2091
                                                                                                                       //
    var computeStagger = function computeStagger(n) {                                                                  // 2093
      // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                        //
      // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                         //
      // The sequence looks like:                                                                                      //
      //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                             //
      //                                                                                                               //
      // We use this to determine how we'll stagger periodic events performed by this replica.                         //
      // Notice that this allows us to compute a stagger which is independent of the number of                         //
      // front-end replicas present; we can add more replicas to the end without affecting how the                     //
      // earlier ones schedule their events.                                                                           //
      var denom = 1;                                                                                                   // 2103
      while (denom <= n) {                                                                                             // 2104
        denom <<= 1;                                                                                                   // 2104
      }var num = n * 2 - denom + 1;                                                                                    // 2104
      return num / denom;                                                                                              // 2106
    };                                                                                                                 // 2107
                                                                                                                       //
    var stagger = computeStagger(replicaNumber);                                                                       // 2109
                                                                                                                       //
    SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                    // 2111
      // Register a database cleanup function than should run periodically, roughly once every                         //
      // interval of the given length.                                                                                 //
      //                                                                                                               //
      // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                      //
      // scaled appropriately on the assumption that more data is being generated demanding more                       //
      // frequent cleanups.                                                                                            //
                                                                                                                       //
      check(intervalMs, Number);                                                                                       // 2119
      check(callback, Function);                                                                                       // 2120
                                                                                                                       //
      if (intervalMs < 120000) {                                                                                       // 2122
        throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");    // 2123
      }                                                                                                                // 2125
                                                                                                                       //
      // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                      //
      // the schedule is independent of the exact startup time.                                                        //
      var first = intervalMs - Date.now() % intervalMs;                                                                // 2129
                                                                                                                       //
      // Stagger cleanups across replicas so that we don't have all replicas trying to clean the                       //
      // same data at the same time.                                                                                   //
      first += Math.floor(intervalMs * computeStagger(replicaNumber));                                                 // 2133
                                                                                                                       //
      // If the stagger put us more than an interval away from now, back up.                                           //
      if (first > intervalMs) first -= intervalMs;                                                                     // 2136
                                                                                                                       //
      Meteor.setTimeout(function () {                                                                                  // 2138
        callback();                                                                                                    // 2139
        Meteor.setInterval(callback, intervalMs);                                                                      // 2140
      }, first);                                                                                                       // 2141
    };                                                                                                                 // 2142
                                                                                                                       //
    // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                          //
    var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                  // 2145
                                                                                                                       //
    var BufferSmallerThan = function BufferSmallerThan(limit) {                                                        // 2147
      return Match.Where(function (buf) {                                                                              // 2148
        check(buf, Buffer);                                                                                            // 2149
        return buf.length < limit;                                                                                     // 2150
      });                                                                                                              // 2151
    };                                                                                                                 // 2152
                                                                                                                       //
    var DatabaseId = Match.Where(function (s) {                                                                        // 2154
      check(s, String);                                                                                                // 2155
      return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                             // 2156
    });                                                                                                                // 2157
                                                                                                                       //
    addStaticAsset = function addStaticAsset(metadata, content) {                                                      // 2159
      // Add a new static asset to the database. If `content` is a string rather than a buffer, it                     //
      // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                  //
                                                                                                                       //
      if (typeof content === "string" && !metadata.encoding) {                                                         // 2163
        content = gzipSync(new Buffer(content, "utf8"));                                                               // 2164
        metadata.encoding = "gzip";                                                                                    // 2165
      }                                                                                                                // 2166
                                                                                                                       //
      check(metadata, {                                                                                                // 2168
        mimeType: String,                                                                                              // 2169
        encoding: Match.Optional("gzip")                                                                               // 2170
      });                                                                                                              // 2168
      check(content, BufferSmallerThan(1 << 20));                                                                      // 2172
                                                                                                                       //
      // Validate content type.                                                                                        //
      metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                    // 2175
                                                                                                                       //
      var hasher = Crypto.createHash("sha256");                                                                        // 2177
      hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                      // 2178
      hasher.update(content);                                                                                          // 2179
      var hash = hasher.digest("base64");                                                                              // 2180
                                                                                                                       //
      var result = StaticAssets.findAndModify({                                                                        // 2182
        query: { hash: hash, refcount: { $gte: 1 } },                                                                  // 2183
        update: { $inc: { refcount: 1 } },                                                                             // 2184
        fields: { _id: 1, refcount: 1 }                                                                                // 2185
      });                                                                                                              // 2182
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2188
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2189
      }                                                                                                                // 2190
                                                                                                                       //
      var existing = result.value;                                                                                     // 2192
      if (existing) {                                                                                                  // 2193
        return existing._id;                                                                                           // 2194
      }                                                                                                                // 2195
                                                                                                                       //
      return StaticAssets.insert(_.extend({                                                                            // 2197
        hash: hash,                                                                                                    // 2198
        content: content,                                                                                              // 2199
        refcount: 1                                                                                                    // 2200
      }, metadata));                                                                                                   // 2197
    };                                                                                                                 // 2202
                                                                                                                       //
    SandstormDb.prototype.addStaticAsset = addStaticAsset;                                                             // 2204
                                                                                                                       //
    SandstormDb.prototype.refStaticAsset = function (id) {                                                             // 2206
      // Increment the refcount on an existing static asset. Returns the asset on success.                             //
      // If the asset does not exist, returns a falsey value.                                                          //
      //                                                                                                               //
      // You must call this BEFORE adding the new reference to the DB, in case of failure between                      //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2214
                                                                                                                       //
      var result = StaticAssets.findAndModify({                                                                        // 2216
        query: { hash: hash },                                                                                         // 2217
        update: { $inc: { refcount: 1 } },                                                                             // 2218
        fields: { _id: 1, content: 1, mimeType: 1 }                                                                    // 2219
      });                                                                                                              // 2216
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2222
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2223
      }                                                                                                                // 2224
                                                                                                                       //
      var existing = result.value;                                                                                     // 2226
      return existing;                                                                                                 // 2227
    };                                                                                                                 // 2228
                                                                                                                       //
    SandstormDb.prototype.unrefStaticAsset = function (id) {                                                           // 2230
      // Decrement refcount on a static asset and delete if it has reached zero.                                       //
      //                                                                                                               //
      // You must call this AFTER removing the reference from the DB, in case of failure between                       //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2237
                                                                                                                       //
      var result = StaticAssets.findAndModify({                                                                        // 2239
        query: { _id: id },                                                                                            // 2240
        update: { $inc: { refcount: -1 } },                                                                            // 2241
        fields: { _id: 1, refcount: 1 },                                                                               // 2242
        "new": true                                                                                                    // 2243
      });                                                                                                              // 2239
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2246
        throw new Error("Couldn't unref static asset " + id);                                                          // 2247
      }                                                                                                                // 2248
                                                                                                                       //
      var existing = result.value;                                                                                     // 2250
      if (!existing) {                                                                                                 // 2251
        console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                       // 2252
      } else if (existing.refcount <= 0) {                                                                             // 2253
        StaticAssets.remove({ _id: existing._id });                                                                    // 2254
      }                                                                                                                // 2255
    };                                                                                                                 // 2256
                                                                                                                       //
    SandstormDb.prototype.getStaticAsset = function (id) {                                                             // 2258
      // Get a static asset's mimeType, encoding, and raw content.                                                     //
                                                                                                                       //
      check(id, String);                                                                                               // 2261
                                                                                                                       //
      var asset = StaticAssets.findOne(id, { fields: { _id: 0, mimeType: 1, encoding: 1, content: 1 } });              // 2263
      if (asset) {                                                                                                     // 2264
        // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                      //
        //   here.                                                                                                     //
        asset.content = new Buffer(asset.content);                                                                     // 2267
      }                                                                                                                // 2268
                                                                                                                       //
      return asset;                                                                                                    // 2270
    };                                                                                                                 // 2271
                                                                                                                       //
    SandstormDb.prototype.newAssetUpload = function (purpose) {                                                        // 2273
      check(purpose, Match.OneOf({ profilePicture: { userId: DatabaseId, identityId: DatabaseId } }, { loginLogo: {} }));
                                                                                                                       //
      return AssetUploadTokens.insert({                                                                                // 2279
        purpose: purpose,                                                                                              // 2280
        expires: new Date(Date.now() + 300000) });                                                                     // 2281
    };                                                                                                                 // 2283
                                                                                                                       //
    // in 5 minutes                                                                                                    //
    SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                         // 2285
      // Indicates that the given asset upload has completed. It will be removed and its purpose                       //
      // returned. If no matching upload exists, returns undefined.                                                    //
                                                                                                                       //
      check(id, String);                                                                                               // 2289
                                                                                                                       //
      var result = AssetUploadTokens.findAndModify({                                                                   // 2291
        query: { _id: id },                                                                                            // 2292
        remove: true                                                                                                   // 2293
      });                                                                                                              // 2291
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2296
        throw new Error("Failed to remove asset upload token");                                                        // 2297
      }                                                                                                                // 2298
                                                                                                                       //
      var upload = result.value;                                                                                       // 2300
                                                                                                                       //
      if (upload.expires.valueOf() < Date.now()) {                                                                     // 2302
        return undefined; // already expired                                                                           // 2303
      } else {                                                                                                         // 2304
          return upload.purpose;                                                                                       // 2305
        }                                                                                                              // 2306
    };                                                                                                                 // 2307
                                                                                                                       //
    SandstormDb.periodicCleanup(3600000, cleanupExpiredAssetUploads);                                                  // 2314
                                                                                                                       //
    // TODO(cleanup): lift this out of the package so it can share with the ones in async-helpers.js                   //
    var Future = Npm.require("fibers/future");                                                                         // 2317
    var promiseToFuture = function promiseToFuture(promise) {                                                          // 2318
      var result = new Future();                                                                                       // 2319
      promise.then(result["return"].bind(result), result["throw"].bind(result));                                       // 2320
      return result;                                                                                                   // 2321
    };                                                                                                                 // 2322
                                                                                                                       //
    var waitPromise = function waitPromise(promise) {                                                                  // 2324
      return promiseToFuture(promise).wait();                                                                          // 2325
    };                                                                                                                 // 2326
                                                                                                                       //
    SandstormDb.prototype.deleteGrains = function (query, backend, type) {                                             // 2328
      var _this8 = this;                                                                                               // 2328
                                                                                                                       //
      // Returns the number of grains deleted.                                                                         //
                                                                                                                       //
      check(type, Match.OneOf("grain", "demoGrain"));                                                                  // 2331
                                                                                                                       //
      var numDeleted = 0;                                                                                              // 2333
      Grains.find(query).forEach(function (grain) {                                                                    // 2334
        waitPromise(backend.deleteGrain(grain._id, grain.userId));                                                     // 2335
        numDeleted += Grains.remove({ _id: grain._id });                                                               // 2336
        _this8.removeApiTokens({                                                                                       // 2337
          grainId: grain._id,                                                                                          // 2338
          $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                            // 2339
        });                                                                                                            // 2337
                                                                                                                       //
        _this8.removeApiTokens({ "owner.grain.grainId": grain._id });                                                  // 2345
                                                                                                                       //
        ActivitySubscriptions.remove({ grainId: grain._id });                                                          // 2347
                                                                                                                       //
        if (grain.lastUsed) {                                                                                          // 2349
          DeleteStats.insert({                                                                                         // 2350
            type: "grain", // Demo grains can never get here!                                                          // 2351
            lastActive: grain.lastUsed,                                                                                // 2352
            appId: grain.appId                                                                                         // 2353
          });                                                                                                          // 2350
        }                                                                                                              // 2355
                                                                                                                       //
        _this8.deleteUnusedPackages(grain.appId);                                                                      // 2357
                                                                                                                       //
        if (grain.size) {                                                                                              // 2359
          Meteor.users.update(grain.userId, { $inc: { storageUsage: -grain.size } });                                  // 2360
        }                                                                                                              // 2361
      });                                                                                                              // 2362
      return numDeleted;                                                                                               // 2363
    };                                                                                                                 // 2364
                                                                                                                       //
    SandstormDb.prototype.userGrainTitle = function (grainId, accountId, identityId) {                                 // 2366
      check(grainId, String);                                                                                          // 2367
      check(accountId, Match.OneOf(String, undefined, null));                                                          // 2368
      check(identityId, String);                                                                                       // 2369
                                                                                                                       //
      var grain = this.getGrain(grainId);                                                                              // 2371
      if (!grain) {                                                                                                    // 2372
        throw new Error("called userGrainTitle() for a grain that doesn't exist");                                     // 2373
      }                                                                                                                // 2374
                                                                                                                       //
      var title = grain.title;                                                                                         // 2376
      if (grain.userId !== accountId) {                                                                                // 2377
        var sharerToken = this.collections.apiTokens.findOne({                                                         // 2378
          grainId: grainId,                                                                                            // 2379
          "owner.user.identityId": identityId                                                                          // 2380
        }, {                                                                                                           // 2378
          sort: {                                                                                                      // 2382
            lastUsed: -1                                                                                               // 2383
          }                                                                                                            // 2382
        });                                                                                                            // 2381
        if (sharerToken) {                                                                                             // 2386
          title = sharerToken.owner.user.title;                                                                        // 2387
        } else {                                                                                                       // 2388
          title = "shared grain";                                                                                      // 2389
        }                                                                                                              // 2390
      }                                                                                                                // 2391
                                                                                                                       //
      return title;                                                                                                    // 2393
    };                                                                                                                 // 2394
                                                                                                                       //
    var packageCache = {};                                                                                             // 2396
    // Package info is immutable. Let's cache to save on mongo queries.                                                //
                                                                                                                       //
    SandstormDb.prototype.getPackage = function (packageId) {                                                          // 2399
      // Get the given package record. Since package info is immutable, cache the data in the server                   //
      // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                       //
      // lot.                                                                                                          //
                                                                                                                       //
      if (packageId in packageCache) {                                                                                 // 2404
        return packageCache[packageId];                                                                                // 2405
      }                                                                                                                // 2406
                                                                                                                       //
      var pkg = Packages.findOne(packageId);                                                                           // 2408
      if (pkg && pkg.status === "ready") {                                                                             // 2409
        packageCache[packageId] = pkg;                                                                                 // 2410
      }                                                                                                                // 2411
                                                                                                                       //
      return pkg;                                                                                                      // 2413
    };                                                                                                                 // 2414
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedPackages = function (appId) {                                                    // 2416
      check(appId, String);                                                                                            // 2417
      Packages.find({ appId: appId }).forEach(function (pkg) {                                                         // 2418
        // Mark package for possible deletion;                                                                         //
        Packages.update({ _id: pkg._id, status: "ready" }, { $set: { shouldCleanup: true } });                         // 2420
      });                                                                                                              // 2421
    };                                                                                                                 // 2422
                                                                                                                       //
    SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
      var _this = this;                                                                                                // 2426
      var actions = _this.collections.userActions.find({ appId: appId, appVersion: { $lt: versionNumber } }, { fields: { userId: 1 } });
      actions.forEach(function (action) {                                                                              // 2429
        var userId = action.userId;                                                                                    // 2430
        var updater = {                                                                                                // 2431
          timestamp: new Date(),                                                                                       // 2432
          isUnread: true                                                                                               // 2433
        };                                                                                                             // 2431
        var inserter = _.extend({ userId: userId, appUpdates: {} }, updater);                                          // 2435
                                                                                                                       //
        // Set only the appId that we care about. Use mongo's dot notation to specify only a single                    //
        // field inside of an object to update                                                                         //
        inserter.appUpdates[appId] = updater["appUpdates." + appId] = {                                                // 2439
          marketingVersion: marketingVersion,                                                                          // 2440
          packageId: packageId,                                                                                        // 2441
          name: name,                                                                                                  // 2442
          version: versionNumber                                                                                       // 2443
        };                                                                                                             // 2439
                                                                                                                       //
        // We unfortunately cannot upsert because upserts can only have field equality conditions in                   //
        // the query. If we try to upsert, Mongo complaints that "$exists" isn't valid to store.                       //
        if (_this.collections.notifications.update({ userId: userId, appUpdates: { $exists: true } }, { $set: updater }) == 0) {
          // Update failed; try an insert instead.                                                                     //
          _this.collections.notifications.insert(inserter);                                                            // 2452
        }                                                                                                              // 2453
      });                                                                                                              // 2454
                                                                                                                       //
      _this.collections.appIndex.update({ _id: appId }, { $set: { hasSentNotifications: true } });                     // 2456
                                                                                                                       //
      // In the case where we replaced a previous notification and that was the only reference to the                  //
      // package, we need to clean it up                                                                               //
      this.deleteUnusedPackages(appId);                                                                                // 2460
    };                                                                                                                 // 2461
                                                                                                                       //
    SandstormDb.prototype.sendReferralProgramNotification = sendReferralProgramNotification;                           // 2463
                                                                                                                       //
    SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                              // 2465
      check(appId, String);                                                                                            // 2466
      check(version, Match.Integer);                                                                                   // 2467
      check(packageId, String);                                                                                        // 2468
                                                                                                                       //
      var selector = {                                                                                                 // 2470
        userId: Meteor.userId(),                                                                                       // 2471
        appId: appId,                                                                                                  // 2472
        appVersion: { $lte: version },                                                                                 // 2473
        packageId: { $ne: packageId }                                                                                  // 2474
      };                                                                                                               // 2470
                                                                                                                       //
      Grains.find(selector).forEach(function (grain) {                                                                 // 2477
        backend.shutdownGrain(grain._id, grain.userId);                                                                // 2478
      });                                                                                                              // 2479
                                                                                                                       //
      Grains.update(selector, {                                                                                        // 2481
        $set: { appVersion: version, packageId: packageId, packageSalt: Random.secret() }                              // 2482
      }, { multi: true });                                                                                             // 2481
    };                                                                                                                 // 2484
                                                                                                                       //
    SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                       // 2486
      // Mark package for possible installation.                                                                       //
                                                                                                                       //
      var fields = {                                                                                                   // 2489
        status: "download",                                                                                            // 2490
        progress: 0,                                                                                                   // 2491
        url: url,                                                                                                      // 2492
        isAutoUpdated: !!isAutoUpdated                                                                                 // 2493
      };                                                                                                               // 2489
                                                                                                                       //
      if (retryFailed) {                                                                                               // 2496
        Packages.update({ _id: packageId, status: "failed" }, { $set: fields });                                       // 2497
      } else {                                                                                                         // 2498
        try {                                                                                                          // 2499
          fields._id = packageId;                                                                                      // 2500
          Packages.insert(fields);                                                                                     // 2501
        } catch (err) {                                                                                                // 2502
          console.error("Simultaneous startInstall()s?", err.stack);                                                   // 2503
        }                                                                                                              // 2504
      }                                                                                                                // 2505
    };                                                                                                                 // 2506
                                                                                                                       //
    var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                  // 2508
      check(keyFingerprint, String);                                                                                   // 2509
      return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                 // 2510
    });                                                                                                                // 2511
                                                                                                                       //
    SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                      // 2513
      // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                   //
                                                                                                                       //
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2516
                                                                                                                       //
      console.log("fetching keybase", keyFingerprint);                                                                 // 2518
                                                                                                                       //
      HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
        timeout: 5000                                                                                                  // 2523
      }, function (err, keybaseResponse) {                                                                             // 2522
        if (err) {                                                                                                     // 2525
          console.log("keybase lookup error:", err.stack);                                                             // 2526
          return;                                                                                                      // 2527
        }                                                                                                              // 2528
                                                                                                                       //
        if (!keybaseResponse.data) {                                                                                   // 2530
          console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                                // 2531
          return;                                                                                                      // 2532
        }                                                                                                              // 2533
                                                                                                                       //
        var profile = (keybaseResponse.data.them || [])[0];                                                            // 2535
                                                                                                                       //
        if (profile) {                                                                                                 // 2537
          // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                       //
          var record = {                                                                                               // 2539
            displayName: (profile.profile || {}).full_name,                                                            // 2540
            handle: (profile.basics || {}).username,                                                                   // 2541
            proofs: (profile.proofs_summary || {}).all || []                                                           // 2542
          };                                                                                                           // 2539
          // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                        //
                                                                                                                       //
          record.proofs.forEach(function (proof) {                                                                     // 2546
            // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                    //
            // this would filter.)                                                                                     //
            for (var field in proof) {                                                                                 // 2549
              // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                    //
              // because I'm too lazy to check the field names recursively (and Keybase doesn't                        //
              // return any objects anyway).                                                                           //
              if (field.match(/[.$]/) || _typeof(proof[field]) === "object") {                                         // 2553
                delete proof[field];                                                                                   // 2554
              }                                                                                                        // 2555
            }                                                                                                          // 2556
                                                                                                                       //
            // Indicate not verified.                                                                                  //
            // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                    //
            //   Keybase node-based CLI.                                                                               //
            proof.status = "unverified";                                                                               // 2561
          });                                                                                                          // 2562
                                                                                                                       //
          KeybaseProfiles.update(keyFingerprint, { $set: record }, { upsert: true });                                  // 2564
        } else {                                                                                                       // 2565
          // Keybase reports no match, so remove what we know of this user. We don't want to remove                    //
          // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                    //
          // from Keybase.                                                                                             //
          //                                                                                                           //
          // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                     //
          //   but at present we don't have the ability to verify proofs.                                              //
          KeybaseProfiles.update(keyFingerprint, { $unset: { displayName: "", handle: "", proofs: "" } }, { upsert: true });
        }                                                                                                              // 2574
      });                                                                                                              // 2575
    };                                                                                                                 // 2576
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                       // 2578
      // If there is an *unused* account that has `identityId` as a login identity, deletes it.                        //
                                                                                                                       //
      check(identityId, String);                                                                                       // 2581
      var account = Meteor.users.findOne({ "loginIdentities.id": identityId });                                        // 2582
      if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !Grains.findOne({ userId: account._id }) && !ApiTokens.findOne({ accountId: account._id }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !Contacts.findOne({ ownerId: account._id })) {
        Meteor.users.remove({ _id: account._id });                                                                     // 2591
        backend.deleteUser(account._id);                                                                               // 2592
      }                                                                                                                // 2593
    };                                                                                                                 // 2594
                                                                                                                       //
    Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                       // 2596
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2597
      var db = this.connection.sandstormDb;                                                                            // 2598
                                                                                                                       //
      var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                                // 2600
      if (cursor.count() === 0) {                                                                                      // 2601
        // Fire off async update.                                                                                      //
        db.updateKeybaseProfileAsync(keyFingerprint);                                                                  // 2603
      }                                                                                                                // 2604
                                                                                                                       //
      return cursor;                                                                                                   // 2606
    });                                                                                                                // 2607
                                                                                                                       //
    Meteor.publish("appIndex", function (appId) {                                                                      // 2609
      check(appId, String);                                                                                            // 2610
      var db = this.connection.sandstormDb;                                                                            // 2611
      var cursor = db.collections.appIndex.find({ _id: appId });                                                       // 2612
      return cursor;                                                                                                   // 2613
    });                                                                                                                // 2614
                                                                                                                       //
    Meteor.publish("userPackages", function () {                                                                       // 2616
      var _this9 = this;                                                                                               // 2616
                                                                                                                       //
      // Users should be able to see packages that are either:                                                         //
      // 1. referenced by one of their userActions                                                                     //
      // 2. referenced by one of their grains                                                                          //
      var db = this.connection.sandstormDb;                                                                            // 2620
                                                                                                                       //
      // Note that package information, once it is in the database, is static. There's no need to                      //
      // reactively subscribe to changes to a package since they don't change. It's also unecessary                    //
      // to reactively remove a package from the client side when it is removed on the server, or                      //
      // when the client stops using it, because the worst case is the client has a small amount                       //
      // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                        //
      // So, we implement this as a cache: the first time each package ID shows up among the user's                    //
      // stuff, we push the package info to the client, and then we never update it.                                   //
      //                                                                                                               //
      // Alternatively, we could subscribe to each individual package query, but this would waste                      //
      // lots of server-side resources watching for events that will never happen or don't matter.                     //
      var hasPackage = {};                                                                                             // 2632
      var refPackage = function refPackage(packageId) {                                                                // 2633
        // Ignore dev apps.                                                                                            //
        if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                            // 2635
                                                                                                                       //
        if (!hasPackage[packageId]) {                                                                                  // 2637
          hasPackage[packageId] = true;                                                                                // 2638
          var pkg = db.getPackage(packageId);                                                                          // 2639
          if (pkg) {                                                                                                   // 2640
            _this9.added("packages", packageId, pkg);                                                                  // 2641
          } else {                                                                                                     // 2642
            console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                 // 2643
          }                                                                                                            // 2645
        }                                                                                                              // 2646
      };                                                                                                               // 2647
                                                                                                                       //
      // package source 1: packages referred to by actions                                                             //
      var actions = db.userActions(this.userId);                                                                       // 2650
      var actionsHandle = actions.observe({                                                                            // 2651
        added: function added(newAction) {                                                                             // 2652
          refPackage(newAction.packageId);                                                                             // 2653
        },                                                                                                             // 2654
                                                                                                                       //
        changed: function changed(newAction, oldAction) {                                                              // 2656
          refPackage(newAction.packageId);                                                                             // 2657
        }                                                                                                              // 2658
      });                                                                                                              // 2651
                                                                                                                       //
      // package source 2: packages referred to by grains directly                                                     //
      var grains = db.userGrains(this.userId);                                                                         // 2662
      var grainsHandle = grains.observe({                                                                              // 2663
        added: function added(newGrain) {                                                                              // 2664
          // Watch out: DevApp grains can lack a packageId.                                                            //
          if (newGrain.packageId) {                                                                                    // 2666
            refPackage(newGrain.packageId);                                                                            // 2667
          }                                                                                                            // 2668
        },                                                                                                             // 2669
                                                                                                                       //
        changed: function changed(newGrain, oldGrain) {                                                                // 2671
          // Watch out: DevApp grains can lack a packageId.                                                            //
          if (newGrain.packageId) {                                                                                    // 2673
            refPackage(newGrain.packageId);                                                                            // 2674
          }                                                                                                            // 2675
        }                                                                                                              // 2676
      });                                                                                                              // 2663
                                                                                                                       //
      this.onStop(function () {                                                                                        // 2679
        actionsHandle.stop();                                                                                          // 2680
        grainsHandle.stop();                                                                                           // 2681
      });                                                                                                              // 2682
                                                                                                                       //
      this.ready();                                                                                                    // 2684
    });                                                                                                                // 2685
  })();                                                                                                                // 2085
}                                                                                                                      // 2686
                                                                                                                       //
var processRawFeatureKey = function processRawFeatureKey(featureKey) {                                                 // 2688
  // Maps the raw data of a signed feature key to the desired "effective" feature key we should use                    //
  // to govern high-level behavior.                                                                                    //
  var processedFeatureKey = _.clone(featureKey);                                                                       // 2691
                                                                                                                       //
  // Hook for future extensibility.                                                                                    //
  return processedFeatureKey;                                                                                          // 2694
};                                                                                                                     // 2695
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2697
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2698
    // Returns an object with all of the current signed feature key properties,                                        //
    // or undefined, if the feature key is missing or not correctly signed.                                            //
    var doc = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                       // 2701
    if (!doc) return undefined;                                                                                        // 2702
    var buf = new Buffer(doc.value);                                                                                   // 2703
    // We use loadSignedFeatureKey from server/feature-key.js.  This should probably get refactored                    //
    // once we can use ES6 modules.                                                                                    //
    var rawFeatureKey = loadSignedFeatureKey(buf);                                                                     // 2706
    return processRawFeatureKey(rawFeatureKey);                                                                        // 2707
  };                                                                                                                   // 2708
} else {                                                                                                               // 2709
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2710
    var featureKey = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                // 2711
    return processRawFeatureKey(featureKey);                                                                           // 2712
  };                                                                                                                   // 2713
}                                                                                                                      // 2714
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2716
  SandstormDb.prototype.deleteIdentity = function (identityId) {                                                       // 2717
    check(identityId, String);                                                                                         // 2718
                                                                                                                       //
    this.removeApiTokens({ "owner.user.identityId": identityId });                                                     // 2720
    this.collections.contacts.remove({ identityId: identityId });                                                      // 2721
    Meteor.users.remove({ _id: identityId });                                                                          // 2722
  };                                                                                                                   // 2723
                                                                                                                       //
  SandstormDb.prototype.deleteAccount = function (userId, backend) {                                                   // 2725
    check(userId, String);                                                                                             // 2726
                                                                                                                       //
    var _this = this;                                                                                                  // 2728
    var user = Meteor.users.findOne({ _id: userId });                                                                  // 2729
    this.deleteGrains({ userId: userId }, backend, "grain");                                                           // 2730
    this.collections.userActions.remove({ userId: userId });                                                           // 2731
    this.collections.notifications.remove({ userId: userId });                                                         // 2732
    user.loginIdentities.forEach(function (identity) {                                                                 // 2733
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               //
        _this.deleteIdentity(identity.id);                                                                             // 2739
      }                                                                                                                // 2740
    });                                                                                                                // 2741
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2742
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               //
        _this.deleteIdentity(identity.id);                                                                             // 2748
      }                                                                                                                // 2749
    });                                                                                                                // 2750
    this.collections.contacts.remove({ ownerId: userId });                                                             // 2751
    backend.deleteUser(userId);                                                                                        // 2752
    Meteor.users.remove({ _id: userId });                                                                              // 2753
  };                                                                                                                   // 2754
                                                                                                                       //
  Meteor.methods({                                                                                                     // 2756
    suspendAccount: function suspendAccount(userId, willDelete) {                                                      // 2757
      check(userId, String);                                                                                           // 2758
      check(willDelete, Boolean);                                                                                      // 2759
                                                                                                                       //
      if (!isAdmin()) {                                                                                                // 2761
        throw new Meteor.Error(403, "Only admins can suspend other users.");                                           // 2762
      }                                                                                                                // 2763
                                                                                                                       //
      this.connection.sandstormDb.suspendAccount(userId, Meteor.userId(), willDelete);                                 // 2765
    },                                                                                                                 // 2766
    deleteOwnAccount: function deleteOwnAccount() {                                                                    // 2768
      var db = this.connection.sandstormDb;                                                                            // 2769
      if (!Meteor.userId()) {                                                                                          // 2770
        throw new Meteor.Error(403, "Must be logged in to delete an account");                                         // 2771
      }                                                                                                                // 2772
                                                                                                                       //
      if (db.isUserInOrganization(Meteor.user())) {                                                                    // 2774
        throw new Meteor.Error(403, "Users in an organization cannot delete their own account. " + "Please ask your admin to do it for you.");
      }                                                                                                                // 2777
                                                                                                                       //
      db.suspendAccount(Meteor.userId(), null, true);                                                                  // 2779
    },                                                                                                                 // 2780
    unsuspendAccount: function unsuspendAccount(userId) {                                                              // 2782
      check(userId, String);                                                                                           // 2783
                                                                                                                       //
      if (!isAdmin()) {                                                                                                // 2785
        throw new Meteor.Error(403, "Only admins can unsuspend other users.");                                         // 2786
      }                                                                                                                // 2787
                                                                                                                       //
      this.connection.sandstormDb.unsuspendAccount(userId, Meteor.userId());                                           // 2789
    },                                                                                                                 // 2790
    unsuspendOwnAccount: function unsuspendOwnAccount() {                                                              // 2792
      if (!Meteor.userId()) {                                                                                          // 2793
        throw new Meteor.Error(403, "Must be logged in to unsuspend an account");                                      // 2794
      }                                                                                                                // 2795
                                                                                                                       //
      this.connection.sandstormDb.unsuspendAccount(Meteor.userId());                                                   // 2797
    }                                                                                                                  // 2798
  });                                                                                                                  // 2756
}                                                                                                                      // 2800
                                                                                                                       //
Meteor.methods({                                                                                                       // 2802
  addUserActions: function addUserActions(packageId) {                                                                 // 2803
    check(packageId, String);                                                                                          // 2804
    if (!this.userId || !Meteor.user().loginIdentities || !isSignedUpOrDemo()) {                                       // 2805
      throw new Meteor.Exception(403, "Must be logged in as a non-guest to add app actions.");                         // 2806
    }                                                                                                                  // 2807
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 2809
      // TODO(cleanup): Appdemo code relies on this being simulated client-side but we don't have                      //
      //   a proper DB object to use.                                                                                  //
      new SandstormDb().addUserActions(this.userId, packageId, true);                                                  // 2812
    } else {                                                                                                           // 2813
      this.connection.sandstormDb.addUserActions(this.userId, packageId);                                              // 2814
    }                                                                                                                  // 2815
  },                                                                                                                   // 2816
  removeUserAction: function removeUserAction(actionId) {                                                              // 2818
    check(actionId, String);                                                                                           // 2819
    if (this.isSimulation) {                                                                                           // 2820
      UserActions.remove({ _id: actionId });                                                                           // 2821
    } else {                                                                                                           // 2822
      if (this.userId) {                                                                                               // 2823
        var result = UserActions.findAndModify({                                                                       // 2824
          query: { _id: actionId, userId: this.userId },                                                               // 2825
          remove: true                                                                                                 // 2826
        });                                                                                                            // 2824
                                                                                                                       //
        if (!result.ok) {                                                                                              // 2829
          throw new Error("Couldn't remove user action " + actionId);                                                  // 2830
        }                                                                                                              // 2831
                                                                                                                       //
        var action = result.value;                                                                                     // 2833
        if (action) {                                                                                                  // 2834
          this.connection.sandstormDb.deleteUnusedPackages(action.appId);                                              // 2835
        }                                                                                                              // 2836
      }                                                                                                                // 2837
    }                                                                                                                  // 2838
  }                                                                                                                    // 2839
});                                                                                                                    // 2802
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/profile.js                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var makeIdenticon = void 0;                                                                                            // 17
var httpProtocol = void 0;                                                                                             // 18
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                    // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                       //
    // has a given identity linked. Automatically stops the subscription if the user loses the                         //
    // identity. Returns a boolean indicating whether the user initially has the identity.                             //
                                                                                                                       //
    var userId = publishHandler.userId;                                                                                // 26
    if (userId === identityId) {                                                                                       // 27
      return true;                                                                                                     // 28
    } else {                                                                                                           // 29
      var _ret = function () {                                                                                         // 29
        var hasIdentityCursor = Meteor.users.find({                                                                    // 30
          $or: [{                                                                                                      // 31
            _id: userId,                                                                                               // 33
            "loginIdentities.id": identityId                                                                           // 34
          }, {                                                                                                         // 32
            _id: userId,                                                                                               // 37
            "nonloginIdentities.id": identityId                                                                        // 38
          }]                                                                                                           // 36
        });                                                                                                            // 30
        if (hasIdentityCursor.count() == 0) {                                                                          // 42
          publishHandler.stop();                                                                                       // 43
          return {                                                                                                     // 44
            v: false                                                                                                   // 44
          };                                                                                                           // 44
        }                                                                                                              // 45
                                                                                                                       //
        var handle = hasIdentityCursor.observe({ removed: function removed() {                                         // 47
            publishHandler.stop();                                                                                     // 47
          } });                                                                                                        // 47
                                                                                                                       //
        publishHandler.onStop(function () {                                                                            // 49
          handle.stop();                                                                                               // 49
        });                                                                                                            // 49
                                                                                                                       //
        return {                                                                                                       // 51
          v: true                                                                                                      // 51
        };                                                                                                             // 51
      }();                                                                                                             // 29
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 29
    }                                                                                                                  // 52
  };                                                                                                                   // 53
                                                                                                                       //
  Meteor.publish("identityProfile", function (identityId) {                                                            // 55
    check(identityId, String);                                                                                         // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                            // 57
                                                                                                                       //
    return Meteor.users.find({ _id: identityId }, { fields: {                                                          // 59
        profile: 1,                                                                                                    // 61
        unverifiedEmail: 1,                                                                                            // 62
        expires: 1,                                                                                                    // 63
        createdAt: 1,                                                                                                  // 64
                                                                                                                       //
        "services.dev.name": 1,                                                                                        // 66
                                                                                                                       //
        "services.google.id": 1,                                                                                       // 68
        "services.google.email": 1,                                                                                    // 69
        "services.google.verified_email": 1,                                                                           // 70
        "services.google.name": 1,                                                                                     // 71
        "services.google.picture": 1,                                                                                  // 72
        "services.google.gender": 1,                                                                                   // 73
        "services.google.hd": 1,                                                                                       // 74
                                                                                                                       //
        "services.github.id": 1,                                                                                       // 76
        "services.github.email": 1,                                                                                    // 77
        "services.github.emails": 1,                                                                                   // 78
        "services.github.username": 1,                                                                                 // 79
                                                                                                                       //
        "services.email.email": 1,                                                                                     // 81
                                                                                                                       //
        "services.ldap.id": 1,                                                                                         // 83
        "services.ldap.username": 1,                                                                                   // 84
        "services.ldap.rawAttrs": 1,                                                                                   // 85
                                                                                                                       //
        "services.saml.id": 1,                                                                                         // 87
        "services.saml.email": 1,                                                                                      // 88
        "services.saml.displayName": 1                                                                                 // 89
      }                                                                                                                // 60
    });                                                                                                                // 60
  }), Meteor.publish("accountIdentities", function () {                                                                // 92
    // Maybe this should be folded into the "credentials" subscription?                                                //
                                                                                                                       //
    if (!this.userId) return [];                                                                                       // 97
                                                                                                                       //
    return Meteor.users.find({ _id: this.userId }, { fields: {                                                         // 99
        profile: 1,                                                                                                    // 102
        verifiedEmail: 1,                                                                                              // 103
        loginIdentities: 1,                                                                                            // 104
        nonloginIdentities: 1,                                                                                         // 105
        expires: 1,                                                                                                    // 106
        primaryEmail: 1                                                                                                // 107
      } });                                                                                                            // 101
  });                                                                                                                  // 109
                                                                                                                       //
  makeIdenticon = function makeIdenticon(id) {                                                                         // 111
    var hash = id.slice(0, 32);                                                                                        // 112
    return httpProtocol + "//" + makeWildcardHost("static") + "/identicon/" + hash + "?s=256";                         // 113
  };                                                                                                                   // 114
                                                                                                                       //
  var Url = Npm.require("url");                                                                                        // 116
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                             // 117
} else {                                                                                                               // 118
  (function () {                                                                                                       // 118
    var identiconCache = {};                                                                                           // 119
                                                                                                                       //
    makeIdenticon = function makeIdenticon(id) {                                                                       // 121
      // Given a cryptographic hash as input, generate an identicon. We always use the user's                          //
      // identity ID as the input hash (the same thing passed to apps as the user ID).                                 //
                                                                                                                       //
      // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                       //
      // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                   //
      // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                      //
      // anyway to be safe.                                                                                            //
      var hash = id.slice(0, 32);                                                                                      // 129
                                                                                                                       //
      if (hash in identiconCache) {                                                                                    // 131
        return identiconCache[hash];                                                                                   // 132
      }                                                                                                                // 133
                                                                                                                       //
      // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                     //
      var data = new Identicon(hash, 512).toString();                                                                  // 136
      var result = "data:image/svg+xml," + encodeURIComponent(data);                                                   // 137
      identiconCache[hash] = result;                                                                                   // 138
      return result;                                                                                                   // 139
    };                                                                                                                 // 140
                                                                                                                       //
    httpProtocol = window.location.protocol;                                                                           // 142
  })();                                                                                                                // 118
}                                                                                                                      // 143
                                                                                                                       //
var GENDERS = { male: "male", female: "female", neutral: "neutral", robot: "robot" };                                  // 145
                                                                                                                       //
function staticAssetUrl(id, staticHost) {                                                                              // 147
  if (id) {                                                                                                            // 148
    return staticHost + "/" + id;                                                                                      // 149
  } else {                                                                                                             // 150
    return undefined;                                                                                                  // 151
  }                                                                                                                    // 152
}                                                                                                                      // 153
                                                                                                                       //
function filterHandle(handle) {                                                                                        // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                            //
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                               // 157
}                                                                                                                      // 158
                                                                                                                       //
function emailToHandle(email) {                                                                                        // 160
  // Turn an email address into a handle.                                                                              //
                                                                                                                       //
  if (!email) return undefined;                                                                                        // 163
                                                                                                                       //
  // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters                         //
  // on the same account.                                                                                              //
  var parts = email.split("@");                                                                                        // 167
  var base = filterHandle(parts[0].split("+")[0]);                                                                     // 168
                                                                                                                       //
  var domain = (parts[1] || "").split(".");                                                                            // 170
  if (domain[domain.length - 1] === "name") {                                                                          // 171
    // Oh, a .name domain. Let's use                                                                                   //
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                 // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                            //
    base = filterHandle(domain[0]);                                                                                    // 181
  }                                                                                                                    // 182
                                                                                                                       //
  return filterHandle(base);                                                                                           // 184
}                                                                                                                      // 185
                                                                                                                       //
SandstormDb.fillInProfileDefaults = function (user) {                                                                  // 187
  var profile = user.profile;                                                                                          // 188
  if (profile.service === "github") {                                                                                  // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                    // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);      // 191
  } else if (profile.service === "google") {                                                                           // 193
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                        // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);        // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                            // 197
  } else if (profile.service === "email") {                                                                            // 198
    var email = user.services.email.email;                                                                             // 199
    profile.name = profile.name || emailToHandle(email);                                                               // 200
    profile.handle = profile.handle || emailToHandle(email);                                                           // 201
  } else if (profile.service === "dev") {                                                                              // 202
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                            // 203
    profile.name = profile.name || user.services.dev.name;                                                             // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                    // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                             // 209
    profile.name = profile.name || "Demo User";                                                                        // 210
    profile.handle = profile.handle || "demo";                                                                         // 211
  } else if (profile.service === "ldap") {                                                                             // 212
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 213
    var key = setting ? setting.value : "";                                                                            // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                    // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                 // 216
  } else if (profile.service === "saml") {                                                                             // 217
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                        // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                   // 219
  } else {                                                                                                             // 220
    throw new Error("unrecognized identity service: ", profile.service);                                               // 221
  }                                                                                                                    // 222
                                                                                                                       //
  profile.pronoun = profile.pronoun || "neutral";                                                                      // 224
};                                                                                                                     // 225
                                                                                                                       //
SandstormDb.fillInIntrinsicName = function (user) {                                                                    // 227
  var profile = user.profile;                                                                                          // 228
  if (profile.service === "github") {                                                                                  // 229
    profile.intrinsicName = user.services.github.username;                                                             // 230
  } else if (profile.service === "google") {                                                                           // 231
    profile.intrinsicName = user.services.google.name;                                                                 // 232
    user.privateIntrinsicName = user.services.google.email;                                                            // 233
  } else if (profile.service === "email") {                                                                            // 234
    profile.intrinsicName = user.services.email.email;                                                                 // 235
  } else if (profile.service === "dev") {                                                                              // 236
    profile.intrinsicName = user.services.dev.name;                                                                    // 237
  } else if (profile.service === "demo") {                                                                             // 238
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                                // 239
  } else if (profile.service === "ldap") {                                                                             // 240
    profile.intrinsicName = user.services.ldap.username;                                                               // 241
  } else if (profile.service === "saml") {                                                                             // 242
    profile.intrinsicName = user.services.saml.id;                                                                     // 243
  } else {                                                                                                             // 244
    throw new Error("unrecognized identity service: ", profile.service);                                               // 245
  }                                                                                                                    // 246
};                                                                                                                     // 247
                                                                                                                       //
SandstormDb.fillInLoginId = function (identity) {                                                                      // 249
  var service = identity.profile.service;                                                                              // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                          // 251
};                                                                                                                     // 252
                                                                                                                       //
SandstormDb.getVerifiedEmails = function (identity) {                                                                  // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {         // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                              //
    return [{ email: identity.services.google.email, primary: true }];                                                 // 257
  } else if (identity.services.email) {                                                                                // 258
    return [{ email: identity.services.email.email, primary: true }];                                                  // 259
  } else if (identity.services.github && identity.services.github.emails) {                                            // 260
    return _.chain(identity.services.github.emails).filter(function (email) {                                          // 261
      return email.verified;                                                                                           // 262
    }).map(function (email) {                                                                                          // 262
      return _.pick(email, "email", "primary");                                                                        // 263
    }).value();                                                                                                        // 263
  } else if (identity.services.ldap) {                                                                                 // 265
    var email = identity.services.ldap.rawAttrs[SandstormDb.prototype.getLdapEmailField()];                            // 266
    if (email) {                                                                                                       // 267
      return [{ email: email, primary: true }];                                                                        // 268
    }                                                                                                                  // 269
  } else if (identity.services.saml && identity.services.saml.email) {                                                 // 270
    return [{ email: identity.services.saml.email, primary: true }];                                                   // 271
  }                                                                                                                    // 272
                                                                                                                       //
  return [];                                                                                                           // 274
};                                                                                                                     // 275
                                                                                                                       //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                       // 277
  // Returns an array of identities which have the given email address as one of their verified                        //
  // addresses.                                                                                                        //
                                                                                                                       //
  check(email, String);                                                                                                // 281
                                                                                                                       //
  return Meteor.users.find({ $or: [{ "services.google.email": email }, { "services.email.email": email }, { "services.github.emails.email": email }, { "services.saml.email": email }] }).fetch().filter(function (identity) {
    // Verify that the email is verified, since our query doesn't technically do that.                                 //
    return !!_findWhere(SandstormDb.getVerifiedEmails(identity), { email: email });                                    // 290
  });                                                                                                                  // 291
};                                                                                                                     // 292
                                                                                                                       //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                         // 294
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                 // 295
  return Meteor.users.find({ $or: [{ "loginIdentities.id": { $in: identityIds } }, { "nonloginIdentities.id": { $in: identityIds } }] }).fetch();
};                                                                                                                     // 300
                                                                                                                       //
SandstormDb.fillInPictureUrl = function (user) {                                                                       // 302
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                   // 303
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);               // 304
};                                                                                                                     // 306
                                                                                                                       //
SandstormDb.getUserIdentityIds = function (user) {                                                                     // 308
  // Given an account user object, returns an array containing the ID of each identity linked to the                   //
  // account. Always returns the most recently added login identity first.                                             //
  if (user && user.loginIdentities) {                                                                                  // 311
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                              // 312
  } else {                                                                                                             // 313
    return [];                                                                                                         // 314
  }                                                                                                                    // 315
};                                                                                                                     // 316
                                                                                                                       //
SandstormDb.getUserEmails = function (user) {                                                                          // 318
  // Given a user object, returns an array containing all email addresses associated with that user.                   //
  // Each entry in the array is an object of the form:                                                                 //
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                    //
  //                                                                                                                   //
  // At most one entry in the result has `primary = true`.                                                             //
  //                                                                                                                   //
  // TODO(cleanup): This actually does need to query the database to fetch profile information                         //
  //   for linked identities, so it probably makes more sense for it to be a non-static method                         //
  //   on SandstormDb.                                                                                                 //
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                              // 329
  var verifiedEmails = {};                                                                                             // 330
  var unverifiedEmails = {};                                                                                           // 331
                                                                                                                       //
  identityIds.forEach(function (id) {                                                                                  // 333
    var identity = Meteor.users.findOne({ _id: id });                                                                  // 334
    if (identity && identity.services) {                                                                               // 335
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                       // 336
        if (verifiedEmail) {                                                                                           // 337
          verifiedEmails[verifiedEmail.email] = true;                                                                  // 338
        }                                                                                                              // 339
      });                                                                                                              // 340
    }                                                                                                                  // 341
                                                                                                                       //
    if (identity && identity.unverifiedEmail) {                                                                        // 343
      unverifiedEmails[identity.unverifiedEmail] = true;                                                               // 344
    }                                                                                                                  // 345
  });                                                                                                                  // 346
                                                                                                                       //
  var result = [];                                                                                                     // 348
  _.keys(verifiedEmails).map(function (email) {                                                                        // 349
    result.push({ email: email,                                                                                        // 350
      verified: true,                                                                                                  // 351
      primary: email === user.primaryEmail });                                                                         // 352
  });                                                                                                                  // 353
                                                                                                                       //
  _.keys(unverifiedEmails).map(function (email) {                                                                      // 355
    if (!(email in verifiedEmails)) {                                                                                  // 356
      result.push({ email: email, verified: false });                                                                  // 356
    }                                                                                                                  // 356
  });                                                                                                                  // 357
                                                                                                                       //
  // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                               //
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                   // 360
    result[0].primary = true;                                                                                          // 361
  }                                                                                                                    // 362
                                                                                                                       //
  return result;                                                                                                       // 364
};                                                                                                                     // 365
                                                                                                                       //
SandstormDb.prototype.addContact = function addContact(ownerId, identityId) {                                          // 367
  check(ownerId, String);                                                                                              // 368
  check(identityId, String);                                                                                           // 369
  var profile = this.getIdentity(identityId).profile;                                                                  // 370
  this.collections.contacts.upsert({ ownerId: ownerId, identityId: identityId }, {                                     // 371
    ownerId: ownerId,                                                                                                  // 372
    petname: profile && profile.name,                                                                                  // 373
    created: new Date(),                                                                                               // 374
    identityId: identityId                                                                                             // 375
  });                                                                                                                  // 371
};                                                                                                                     // 377
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
